
#include <libCMU.h>
#include "soccer.h"

Position Pos[12];

enum PASS_FLAG{
	Flag_none,
	Flag_pass,
}pass_flag;

float pass_kick_ang;

int my_time;

void behave(){

	switch (Mem->PlayMode){ 
	case PM_Before_Kick_Off:
		pass_flag = Flag_none;
		Mem->update_offside_lines();

		if(Mem->KickOffMode == KO_Mine)
			my_time = Mem->CurrentTime.t;
		
		formation();

		Pos[Mem->MyNumber].p1.x = 0;
		Pos[Mem->MyNumber].p1.y = 0;
		return;
		break;

	case PM_My_Kick_Off:
		pass_flag = Flag_none;
		Mem->update_offside_lines();
	 	if((Mem->MyNumber % 2) == 1){
			if(Mem->BallKickable()){		
				kick_ball(Vector(-20,0));
				return;
			}else{
				get_ball();
				return;
			}
		}
		face_ball();
		return;
		break;

	case PM_Their_Kick_Off:
		pass_flag = Flag_none;
		Mem->update_offside_lines();
		face_ball();
		return;
		break;

	case PM_Their_Corner_Kick:
		pass_flag = Flag_none;
		if(Mem->BallDistance() < 9.5){
			face_ball();
			return;
		}
		break;

	case PM_Their_Free_Kick:
		pass_flag = Flag_none;
		Mem->update();
		if(Mem->BallDistance() < 9.5){
			face_ball();
			return;
		}
		if(Mem->BallAbsolutePosition().x > 32){
			their_goal_position();
			return;
		}
		new_position();
		return;
		break;

	case PM_My_Free_Kick:
		if(Mem->BallAbsolutePosition().x < 0){
			switch(Pos[Mem->MyNumber].part){
			case SW:
			case DMF:
				if(Mem->BallKickable(1.0)){
					if(pass()){
						return;
					}else{
						dribble();
						return;
					}
				}else{
					go_to_point(Mem->BallAbsolutePosition(),0,20);
					return;
				}

				break;

			default:
				new_position();
				return;
				break;
			}
		}
		break;

	case PM_Their_Goal_Kick:
	{	
		pass_flag = Flag_none;
//		int first, second;
//		Vector first_opp_pos;
//		first = second = 0;

		if(Mem->MyX() > 35.5){
			if(go_to_point(Vector(33,Mem->MyY()),0.5,20) == AQ_ActionNotQueued){
				face_ball();
	     			return;
			}
		}
		
		if(fabs(Mem->MyPos().y) < 17 && Mem->MyX() > 35.5){
			face_ball();
			Mem->update_offside_lines();
			return;
		}
		their_goal_position();
		return;
	}
	break;

	case PM_My_Goal_Kick:
		pass_flag = Flag_none;	
		switch(Pos[Mem->MyNumber].part){
		case FW:
			if(!teammate_offside(Mem->MyNumber)){
				return;
			}else{
				new_position();
				return;
			}
		break;
		case SW:
		{
			Vector ball = Mem->BallAbsolutePosition();
			if(Mem->BallKickable()){
				if(DribbleTo(Mem->MarkerPosition(Mem->RM_My_PC_Flag),
				   30,1,0,DM_Lazy,FALSE,Vector(0,0)) == DR_None){
					if(pass()){
						return;
					}
				}
			}else{
				go_to_point(ball,0,20);
				return;
			}
		}
		break;

		default:
			new_position();
			return;
		break;

		}

	break;
	  
	case PM_Their_Kick_In:
		pass_flag = Flag_none;
	     	if(Mem->BallDistance() < 9.5){
			face_ball();
		}else{
			their_kick_in_position();
		}
		return;
	break;

	case PM_My_Kick_In:
	case PM_My_Corner_Kick:
		pass_flag = Flag_none;
		switch(Pos[Mem->MyNumber].part){
		case RMF:
		case LMF:
			if(Mem->BallAbsolutePosition().y < 0 && Pos[Mem->MyNumber].part == RMF){
				new_position();
				return;
			}else if(Mem->BallAbsolutePosition().y > 0 && Pos[Mem->MyNumber].part == LMF){
				new_position();
				return;
			}

			if(Mem->BallKickable(0.8)){
				if(pass()){
					return;
				}else{
					dribble();
					return;
				}
			}else{
				go_to_point(Mem->BallAbsolutePosition(),0,20);
				return;
			}

		break;
		
		default:
			my_kick_in_position();
			return;
		break;
		}
	break;

	default:
		pass_flag = Flag_none;
		say_counter = 0 ;
		dance_counter = 0 ;

	break;
	}

	if((Pos[Mem->MyNumber].part == FW) && Mem->CurrentTime.t < my_time + 20
	   && Mem->BallX() < 0){
		go_to_point(Vector(offside_line() - 3, Mem->MyY()), 0.5, 100);
		return;
	}

	if(!Mem->BallPositionValid()){
		face_ball();
		return;
	}


//------------------------------------------------------------------------
//                 åոư
//                      ܡɤ
//------------------------------------------------------------------------

	printf("\ntime = %d.%d\n",Mem->CurrentTime.t,Mem->CurrentTime.s);
printf("my pos X = %f    Y = %f\n",Mem->MyX(), Mem->MyY());
printf("ball   X = %f    Y = %f\n",Mem->BallX(), Mem->BallY());

	switch(Pos[Mem->MyNumber].part){
	case FW:
	{
		printf("%d  FW\n",Mem->MyNumber);
		
		Unum* player;
		player = new Unum[11];
		Rectangle rect = Rectangle(33,52.5,-17,17);

	// ݥΰư  (ݥͿ)
		if((offside_line() - Mem->BallAbsolutePosition().x) > 20){
			new_position();
		}else if(Mem->BallKickable()){
			if(Mem->MarkerDistance(Mem->RM_Their_Goal) < LAST_SHOOT_DIS ){
				shoot1();
//			}else if(Mem->MarkerDistance(Mem->RM_Their_Goal) < 25 ){
			}else if(rect.IsWithin(Mem->MyPos())){
				shoot();  //ζŤƤ⥷塼Ȥʤ
	//			shoot1(); //  ˶դ饷塼
			}else if(Mem->MyPos().x > 42 && fabs(Mem->MyPos().y) > 14){
				//󥿥
				Vector point = Vector(offside_line() - 5, 0);
				kick_ball(point, Mem->BestKickModeAbs(point.dir()));
			}else if(Mem->MarkerDistance(Mem->RM_RF_Flag) < 13){
				Vector point = Vector(offside_line() - 5, 0);
				kick_ball(point, Mem->BestKickModeAbs(point.dir()));
			}else if(Mem->MarkerDistance(Mem->RM_LF_Flag) < 13){
				Vector point = Vector(offside_line() - 5, 0);
				kick_ball(point, Mem->BestKickModeAbs(point.dir()));
//			}else if(fabs(Mem->AngleTo(Mem->MarkerPosition(Mem->RM_Their_Goal))) < 70){
//				// Ƥ
//				dribble();	// ѥ
			}else{
				if(Mem->ClosestOpponent() != Unum_Unknown){
					if(Mem->OpponentDistance(Mem->ClosestOpponent()) < 5){
						if(pass()){
							return;
						}else{
							dribble();
						}
					}else{
						if(my_turn())
							dribble();
						else
							printf("AAAAA\n");
						return;
					}
				}else{
					if(my_turn())
						dribble();
					else
						printf("AAAAA\n");
					return;
				}
			}
		}else if(Mem->TheirPenaltyArea.IsWithin(Mem->BallAbsolutePosition()) && Mem->MarkerDistance(Mem->RM_Their_Goal) < 18 ){
			go_ball();
		}else if(Mem->TeammateWithBall(-1) > 0  && Mem->TeammateWithBall(-1) != Mem->MyNumber && 
			 Mem->BallAbsolutePosition().x > 10){
//			OF_run_select();
			new_position();
		}else if(Mem->OpponentWithBall(-1) > 0 && Mem->BallAbsolutePosition().x > 10){
			DF_run_select();
		}else{
			// 롼ܡ
			printf("%d roozu\n",Mem->MyNumber);

			if(Mem->ClosestTeammateToBall() == Mem->MyNumber){
printf("Closest Teammate\n");
				go_ball();
			}else if(first_intercepter() == Mem->MyNumber){
printf("first intercepter\n");
				go_ball();
			}else if(ball_to_my(5) && my_in_cone_team(Mem->BallAbsolutePosition()) > 2){
printf("ball_to_my\n");
				new_position();
			}else if(who_pass_team() == Mem->MyNumber){
printf("who_pass_team\n");
				go_ball();				
//			}else if(ball_to_my(5) && Mem->MyPos().dist(ball_stop_position()) < 10
//				 && Mem->MyInterceptionAble()){
			}else if(ball_to_my(5)){
printf("interceptionable\n");
				go_ball();
//			}else if(Mem->BallDistance() < 5 && Mem->MyInterceptionAble()){
////				go_to_point(Mem->MyInterceptionPoint());
//				go_ball();
//			}else if(Mem->BallDistance() <= 5){
//				go_ball();
////			}else if(Mem->PlayerWithBall() > 0){
////				face_ball();
			}else if((ball_to_point(Vector(32,0),5)) && 
				 (ball_stop_position().dist(Vector(32,0)) < 7) && 
				 (ball_in_cone_opp(Vector(32,0)) < 0)){
				go_to_point(Vector(32,0),3,60);
			}else{
				new_position();
				return;
			}
		}
	}
		break;


	case SW:
		{
		printf("%d  SW\n",Mem->MyNumber);
		if(Mem->BallKickable()){
			if(Mem->MarkerDistance(Mem->RM_Their_Goal) < SECOND_SHOOT_DIS ){
				shoot1();
				return;
			}
		}

		if(pass()){ 
			pass_flag = Flag_pass;
			return;
		}

		if(offside_trap_check()){
			offside_trap();
			return;
		}
		if(ball_to_my(5) && Mem->MyInterceptionAble()){
			go_to_point(Mem->MyInterceptionPoint());
			return;
		}

		if(first_intercepter() == Mem->MyNumber){
			go_to_point(Mem->MyInterceptionPoint());
			return;
		}

		if(Mem->ClosestTeammateToBall() == Mem->MyNumber){
			go_ball();
			return;
		}

		if(Mem->PlayerWithBall() < 0){
			covering();
			return;
		}

		new_position();
		return;

		break;
		}

	case FMF:
		{
		if(pass_flag == Flag_pass){
			if(Mem->PlayerWithBall(-2) != 0 &&
			   Mem->PlayerWithBall(-2) != Mem->MyNumber){
				pass_flag = Flag_none;
			}
			if(ball_to_my(5)){
				pass_flag = Flag_none;
			}
			if(Mem->BallRelativeVelocity().y != 0){
				if(fabs(pass_kick_ang - Mem->BallRelativeVelocity().x / 
				  Mem->BallRelativeVelocity().y) > 0.5){
					pass_flag = Flag_none;
				}
			}
		}


		if(Mem->BallKickable()){

			if(Mem->MarkerDistance(Mem->RM_Their_Goal) < SECOND_SHOOT_DIS ){
				shoot1();       
				return;
			}else if(Mem->MyX() > offside_line() - 2){
				dribble();
				return;
			}else if(pass()){
				pass_flag = Flag_pass;
				if(Mem->BallRelativeVelocity().y != 0){
					pass_kick_ang = Mem->BallRelativeVelocity().x / 
					  Mem->BallRelativeVelocity().y;
				}
				return;
			}else{
				dribble();
				return;
			}
		}

		if(Mem->PlayerWithBall(-1) > 0 && Mem->PlayerWithBall(-1) != Mem->MyNumber){
			new_position();
			return;
		}
			
		if(ball_to_my(5) && Mem->MyInterceptionAble()){
			go_to_point(Mem->MyInterceptionPoint());
			return;
		}

		if(first_intercepter() == Mem->MyNumber){
			go_to_point(Mem->MyInterceptionPoint());
			return;
		}

		if(Mem->BallDistance() < 10 && Mem->MyInterceptionAble()){
			go_ball();
			return;
		}

		if(Mem->ClosestTeammateToBall() == Mem->MyNumber){
			go_ball();
			return;
		}else if(Mem->BallDistance() <= 5){
			go_ball();
			return;
		}

		if(Mem->OpponentWithBall(-2) > 0){
			DF_run_select();
			return;
		}


		new_position();

		break;

		}

	default:
		{

		if(Mem->BallKickable()){
			if(Mem->MarkerDistance(Mem->RM_Their_Goal) < SECOND_SHOOT_DIS ){
				shoot1();
				return;
			}else if(Mem->BallAbsolutePosition().x > 35){
				kick_ball(Mem->MarkerPosition(Mem->RM_Their_PC_Flag),KM_HardestKick);
				return;
			}else if(pass()){
				pass_flag = Flag_pass;
				return;
			}else{
				dribble();
				return;
			}
		}

		if(ball_to_my(5) && Mem->MyInterceptionAble() && 
		   Mem->BallDistance() < 20){
			go_to_point(Mem->MyInterceptionPoint());
			return;
		}

		if(first_intercepter() == Mem->MyNumber){
			go_to_point(Mem->MyInterceptionPoint());
			return;
		}

		if(Mem->ClosestTeammateToBall() == Mem->MyNumber){
			go_ball();
			return;
		}

		if(Mem->PlayerWithBall(-1) < 0){
			face_ball();
			return;
		}else{
			new_position();
			return;
		}

		new_position();

		break;

		}

	}
}

//-------------------------------------------------------------------------
//                    åդΥݥ
//-------------------------------------------------------------------------
void formation()
{
	char saybuf[512] ;
	sprintf ( saybuf,"(say Zeng99-ACamp99+alpha)") ;

// ե᡼Υݥ


/*
	Pos[1].p0.x = -9.14; 	Pos[1].p0.y = 0;  	Pos[1].part = FMF;
	Pos[2].p0.x = -1;	Pos[2].p0.y = 5; 	Pos[2].part = FW;
	Pos[3].p0.x = -.4;	Pos[3].p0.y = 0; 	Pos[3].part = FW;
*/

	Pos[1].p0.x = -50; 	Pos[1].p0.y = 0;  	Pos[1].part = GK;
//	Pos[1].p0.x = -1;	Pos[1].p0.y = -0.1; 	Pos[1].part = FW;
	Pos[2].p0.x = -35; 	Pos[2].p0.y = 0;  	Pos[2].part = SW;
//	Pos[2].p0.x = -.4; 	Pos[2].p0.y = 5;  	Pos[2].part = FW;
	Pos[3].p0.x = -25; 	Pos[3].p0.y = -13;  	Pos[3].part = DF;
	Pos[4].p0.x = -25; 	Pos[4].p0.y = 0;  	Pos[4].part = DF;
	Pos[5].p0.x = -25; 	Pos[5].p0.y = 13;  	Pos[5].part = DF;
	Pos[6].p0.x = -10; 	Pos[6].p0.y = -20;  	Pos[6].part = LMF;
	Pos[7].p0.x = -15; 	Pos[7].p0.y = 0;  	Pos[7].part = DMF;
	Pos[8].p0.x = -10; 	Pos[8].p0.y = 20;  	Pos[8].part = RMF;
//	Pos[9].p0.x = -.4; 	Pos[9].p0.y = 20;  	Pos[9].part = WF;
	Pos[9].p0.x = -9.5; 	Pos[9].p0.y = 0;  	Pos[9].part = FMF;
	Pos[10].p0.x = -1;	Pos[10].p0.y = 5; 	Pos[10].part = FW;
	Pos[11].p0.x = -.5;	Pos[11].p0.y =-0.7; 	Pos[11].part = FW;
	
	if ( Mem->KickOffMode == KO_Mine )
	{
		if (Pos[Mem->MyNumber].p0.dist(Mem->MyPos()) > 0.5)
		{
			move(Pos[Mem->MyNumber].p0);
		}
		else if ( say_counter ++ < 1 )
		{
			send_message( saybuf, Mem->sock ) ;	 
		}
	}
	else if ( Mem->KickOffMode == KO_Theirs )
	{
		Pos[10].p0.x = -1;	Pos[10].p0.y = 9.5;
		Pos[11].p0.x = -1;	Pos[11].p0.y = -9.5;
		if (Pos[Mem->MyNumber].p0.dist(Mem->MyPos()) > 1)
		{
			move(Pos[Mem->MyNumber].p0);
		}
		else if ( say_counter ++ < 1 )
		{
			send_message( saybuf, Mem->sock ) ;
		}
	}

//	move(Pos[Mem->MyNumber].p0.x, Pos[Mem->MyNumber].p0.y);


}
int	say_counter ;
int	dance_counter ;
	

int main(int argc, char* argv[]){
  say_counter = 0 ;
  dance_counter = 0 ;

  CMU_main(argc, argv, NULL);
}
