#ifndef	   RAD_DIG_H_INCLUDED
#define	   RAD_DIG_H_INCLUDED

#ifdef HAVE_CONFIG_H
# include  "config.h"
#endif


#include  <cmath>

inline
double  dig_to_rad( double  dig )
{
	return( dig / 180.0 * M_PI );
}

inline
double  rad_to_dig( double  rad )
{
	return( rad / M_PI * 180.0 );
}


inline
double  normalize_angle( double  dir ,  bool use_radian = true )
{
	double	half;

	if ( use_radian )
	{
		half = M_PI;
	}
	else
	{
		half = 180.0;
	}

	if ( dir >= half )
	{
		do
		{
			dir -= 2.0 * half;
		} while( dir >= half );
	}
	else if ( dir < (-half) )
	{
		do
		{
			dir += 2.0 * half;
		} while( dir < (-half) );
	}

	return( dir );
}


#endif	/* RAD_DIG_H_INCLUDED */
