#ifndef	   COMMAND_QUEUE_H_INCLUDED
#define	   COMMAND_QUEUE_H_INCLUDED

//
// Command_Queue
//
#include  "soccer_composite_command.h"
#include  "soccer_action.h"
#include  "ref_count_ptr.h"
#include  <queue>
#include  <stdexcept>

class  Command_Queue
{
protected:
	struct  Command_or_Action
	{
		bool	is_command;

		Soccer_Composite_Command	command;
		ref_count_ptr<Soccer_Action>	action;
	};

	mutable	std::queue<Command_or_Action>	q;

	void	remove_finished_action() const throw();

public:
	 Command_Queue() throw();
	 Command_Queue( const Soccer_Composite_Command &  com ) throw();
	 Command_Queue( const ref_count_ptr<Soccer_Action> &  act ) throw();
	 Command_Queue( Soccer_Action *  act ) throw();
	~Command_Queue() throw();

	Command_Queue&	push( const Soccer_Composite_Command &  com ) throw();
	Command_Queue&	push( const ref_count_ptr<Soccer_Action> &  act )
								throw();
	Command_Queue&	push( Soccer_Action *  act ) throw();

	Command_Queue&	push( const Soccer_Composite_Command &  com_1 ,
			      const Soccer_Composite_Command &  com_2 )
								throw();

	Soccer_Composite_Command	pop() throw( std::exception );
	bool		empty() const throw();

	void		clear() throw();

	operator bool() const;
};


//
// Multiple_Queue_Controler
//
#include  "command_queue.h" // not needed
#include  "soccer_action.h"
#include  "ref_count_ptr.h"
#include  <set>

class  Exclusive_Queue_Controler
{
protected:
	std::set<Command_Queue *>	queue_set;

public:
	 Exclusive_Queue_Controler();
	~Exclusive_Queue_Controler();

	Command_Queue *	register_queue( Command_Queue *  q ) throw();


	Command_Queue &	push( Command_Queue &  q ,
			      const Soccer_Composite_Command &  com ) throw();

	Command_Queue &	push( Command_Queue &  q ,
			      const Soccer_Composite_Command & com_1 ,
			      const Soccer_Composite_Command & com_2 ) throw();

	Command_Queue &	push( Command_Queue &  q ,
			      const ref_count_ptr<Soccer_Action> &  act )
								throw();
	Command_Queue &	push( Command_Queue &  q ,
			      Soccer_Action *  act ) throw();


	const  Command_Queue &	clear_other_queue( const Command_Queue &  q )
								throw();

	void	clear_all_queue() throw();
};


#endif	/* COMMAND_QUEUE_H_INCLUDED */
