#include  "miscfuncs.h"
#include  "field_recog_abstract.h"
#include  "sserver_misc_funcs.h"
#include  <cmath>

int    n_turn_to_reach( const ref_count_ptr<Field_Recog_Abstract> &  field ,
			const SObject_Player_Identifier &  player ,
			const D2_Vector &  point ) throw()
{
	try
	{
		D2_Vector	player_pos;
		player_pos = field -> get_player_coordinate(
				   player.side , player.player_number );

		// XXX
		double	dist = (point - player_pos).r()
				/ field -> sserver_param().kickable_distance();

		dist -= field -> sserver_param().kickable_distance();

		return( static_cast<int>(ceil( dist ) + 0.5) );
	}
	catch(...)
	{
		return( -1 );
	}
}


// XXX
int   n_turn_to_reach_ball(
		   const ref_count_ptr<Field_Recog_Abstract> &  field ,
		   const SObject_Player_Identifier &  player ) throw()
{
	try
	{
		for ( int  t = 0  ;  ;  t ++ )
		{
			D2_Vector	ball;

			ball = ball_point_n_turn_later(
					  field -> sserver_param() ,
					  field -> get_ball_coordinate() ,
					  field -> get_ball_vector() ,
					  t );
			int	n = n_turn_to_reach( field , player , ball );

			if ( n <= t )
			{
				return( t );
			}
		}
	}
	catch(...)
	{
		return( -1 );
	}
}


int   get_catchable_turn( const ref_count_ptr<Field_Recog_Abstract> &  field ,
			  int *  own ,  int *  opp ,  int *  our ) throw()
{
	int	own_catchable_turn = -1;
	int	opp_catchable_turn = -1;
	int	our_catchable_turn = -1;

	SObject_Player_Identifier	player;

	player.side = S_Side::Opponent_Side;
	if ( opp )
	{
		for( int  i = 0  ;  i < static_cast<int>(ELEVEN)  ;  i ++ )
		{
			player.player_number = i;

			int	t = n_turn_to_reach_ball( field , player );

			if ( t != -1
			     &&  t < opp_catchable_turn )
			{
				opp_catchable_turn = t;
			}
		}

		*opp = opp_catchable_turn;
	}


	player.side = S_Side::Our_Side;
	if ( our )
	{
		for( int  i = 0  ;  i < static_cast<int>(ELEVEN)  ;  i ++ )
		{
			if ( i == field -> my_player_number() )
			{
				continue;
			}

			player.player_number = i;

			int	t = n_turn_to_reach_ball( field , player );

			if ( t != -1
			     &&  t < opp_catchable_turn )
			{
				opp_catchable_turn = t;
			}
		}

		*our = our_catchable_turn;
	}

	player.player_number = field -> my_player_number();
	if ( own )
	{
		own_catchable_turn = n_turn_to_reach_ball( field , player );

		*own = own_catchable_turn;
	}

	if ( (own == NULL || *own != -1)
	  && (opp == NULL || *opp != -1)
	  && (our == NULL || *our != -1) )
	{
		return( 0 );
	}
	else
	{
		return( -1 );
	}
}
