#include  "sserver_connection_with_game_info.h"
#include  <cassert>

///
/// Warning: SServer_Connection_with_Game_Info is deprecated.
///

SServer_Connection_with_Game_Info::SServer_Connection_with_Game_Info(
				        SServer_IO *  io ,
					bool  use_send_radian ,
					bool  use_recv_radian ,
					long  default_wait_time )
	: SServer_Connection( io , use_send_radian , use_recv_radian ,
			      default_wait_time )
{
}


SServer_Connection_with_Game_Info::SServer_Connection_with_Game_Info(
					const string &  host ,
					in_port_t  port ,
					bool  use_send_radian ,
					bool  use_recv_radian ,
					long  default_wait_time ,
					long  max_response )
	: SServer_Connection( host , port , use_send_radian , use_recv_radian ,
			      default_wait_time , max_response )
{
}


SServer_Connection_with_Game_Info::~SServer_Connection_with_Game_Info()
{
}

bool   SServer_Connection_with_Game_Info::registered()
{
	return( my_player_number() >= 1 );
}


Play_Mode  SServer_Connection_with_Game_Info::play_mode() const throw()
{
	return( game_info.play_mode );
}

int    SServer_Connection_with_Game_Info::my_player_number() const throw()
{
	return( game_info.my_player_number );
}

int    SServer_Connection_with_Game_Info::our_point() const throw()
{
	return( game_info.our_point );
}

int    SServer_Connection_with_Game_Info::opponent_point() const throw()
{
	return( game_info.opponent_point );
}



int    SServer_Connection_with_Game_Info::send_init( const string &  team_name,
						     bool  goalie ,
						     Game_Info *  g_info ,
						     int  major_version ,
						     int  minor_version )
{
	int	ret = SServer_Connection::send_init( team_name ,
						     goalie ,
						     &(this -> game_info) ,
						     major_version ,
						     minor_version  );

	if ( g_info )
	{
		*g_info = this -> game_info;
	}

	return( ret );
}

int    SServer_Connection_with_Game_Info::send_init(
					    const string &  team_name ,
					    bool  goalie ,
					    Game_Info *  g_info )
{
	return( this -> send_init( team_name ,
				   goalie ,
				   g_info ,
				   SSERVER_DEFAULT_MAJOR_VERSION ,
				   SSERVER_DEFAULT_MINOR_VERSION ) );
}

int    SServer_Connection_with_Game_Info::send_reconnect(
						 const string &  team_name ,
						 int  player_number ,
						 Game_Info *  g_info ,
						 long  interval_usec )
{
	int	ret = SServer_Connection::send_reconnect(
						team_name ,
						player_number ,
						&(this -> game_info) ,
						interval_usec );

	if ( g_info )
	{
		*g_info = this -> game_info;
	}

	return( ret );
}



int    SServer_Connection_with_Game_Info::send_reconnect(
						 const string &  team_name ,
						 int  player_number ,
						 Game_Info *  g_info ,
						 bool  default_wait )
{
	int	ret = SServer_Connection::send_reconnect(
						team_name ,
						player_number ,
						&(this -> game_info) ,
						default_wait );
	if ( g_info )
	{
		*g_info = this -> game_info;
	}

	return( ret );
}



Information_from_Server  SServer_Connection_with_Game_Info::
					recv_info( bool  block )
{
	Information_from_Server	info = SServer_Connection::recv_info( block );

	this -> register_info( info );

	return( info );
}


Information_from_Server  SServer_Connection_with_Game_Info::
					recv_info( long  usec )
{
	Information_from_Server	info = SServer_Connection::recv_info( usec );

	this -> register_info( info );

	return( info );
}


Information_from_Server  SServer_Connection_with_Game_Info::
					recv_info( int  usec )
{
	Information_from_Server	info = SServer_Connection::recv_info( usec );

	this -> register_info( info );

	return( info );
}


void   SServer_Connection_with_Game_Info::register_info(
				    const Information_from_Server &  info )
{
	if ( info.type() == Information_from_Server::Type_Whistle )
	{
		Whistle_Info_from_Server	whistle
			= info.get_whistle_info();

		if ( whistle.type
		     == Judgement_Type::One_of_Play_Modes )
		{
			this -> game_info.play_mode = whistle.play_mode;
		}
		else if ( whistle.type == Judgement_Type::Goal )
		{
			if ( whistle.side == S_Side::Our_Side )
			{
				this -> game_info.our_point
					= whistle.point;
			}
			else
			{
				this -> game_info.opponent_point
					= whistle.point;
			}
		}
	}
}
