#ifndef	   SSERVER_CONNECTION_WITH_GAME_INFO_H_INCLUDED
#define	   SSERVER_CONNECTION_WITH_GAME_INFO_H_INCLUDED

#include  "sserver_connection.h"
#include  "s_basic.h"

///
/// Warning: SServer_Connection_with_Game_Info is deprecated.
///

//
// SServer_Connection_with_Game_Info
//
class  SServer_Connection_with_Game_Info : public SServer_Connection
{
protected:
	Game_Info	game_info;

	void		register_info( const Information_from_Server &  info );

public:
	 SServer_Connection_with_Game_Info(
		const std::string &  host = "localhost" ,
		in_port_t  port = SServer_Connection::SSERVER_DEFAULT_PORT ,
		bool  use_send_radian = true ,
		bool  use_recv_radian = true ,
		long  default_wait_time = SServer_Connection::TURN_INTERVAL ,
		long  max_response = 0 );

	 SServer_Connection_with_Game_Info(
		SServer_IO *  io ,
		bool  use_send_radian = true ,
		bool  use_recv_radian = true ,
		long  default_wait_time = SServer_Connection::TURN_INTERVAL );

virtual	~SServer_Connection_with_Game_Info();

	// Don't allow this.
	 SServer_Connection_with_Game_Info(
				   const SServer_Connection_with_Game_Info & );
	// Don't allow this.
	 SServer_Connection_with_Game_Info &  operator=(
				   const SServer_Connection_with_Game_Info & );

virtual	bool		registered();

virtual	Play_Mode	play_mode() const throw();
virtual	int		my_player_number() const throw();
virtual	int		our_point() const throw();
virtual	int		opponent_point() const throw();



	// overwrite SServer_Connection::*()
virtual	int	send_init(
		    const std::string &  team_name ,
		    bool  goalie = false ,
		    Game_Info *  g_info = NULL ,
		    int  major_version
			 = SServer_Connection::SSERVER_DEFAULT_MAJOR_VERSION ,
		    int  minor_version
			 = SServer_Connection::SSERVER_DEFAULT_MINOR_VERSION );

virtual	int	send_init( const std::string &  team_name ,
			   bool  goalie ,
			   Game_Info *  g_info );

virtual	int	send_reconnect( const std::string &  team_name ,
				int  player_number ,
				Game_Info *  g_info = NULL ,
				long  interval_usec = 0 );

virtual	int	send_reconnect( const std::string &  team_name ,
				int  player_number ,
				Game_Info *  g_info ,
				bool  default_wait );

virtual	Information_from_Server		recv_info( bool  block = false );
virtual	Information_from_Server		recv_info( long  usec );
virtual	Information_from_Server		recv_info( int  usec );
};


#endif	/* SSERVER_CONNECTION_WITH_GAME_INFO_H_INCLUDED */
