#ifdef    SSERVER_MESSAGE_TRANSLATOR_TEST
#include  "sserver_message_translator.h"
#include  <string>
#include  <iostream>

#include  "prof_stopwatch.h"
#include  <unistd.h>

using namespace std;

int    main( void )
{
	Information_from_Server	info;

#if 0
#if 0
	string	input = "(sense_body 12 (view_mode high normal) (stamina 2000 0.5) (speed 2.2) (head_angle 3.6) (kick 2) (dash 7) (turn 5) (say 9) (turn_neck 4))\n";
#else
	string	input = "(see 0 ((Goal) 2.5 180) ((goal r) 102.5 0) ((flag c) 49.9 0) ((flag r t) 107.8 -18) ((flag r b) 107.8 18) ((flag p l c) 14 0 -0 0) ((flag p r t) 88.2 -13) ((flag p r c) 85.6 0) ((flag p r b) 88.2 13) ((flag g r t) 102.5 -3) ((flag g r b) 102.5 3) ((flag t r 50) 107.8 -21) ((flag b r 50) 107.8 21) ((flag r t 30) 111.1 -15) ((flag r t 20) 108.9 -10) ((flag r t 10) 107.8 -5) ((flag r 0) 107.8 0) ((flag r b 10) 107.8 5) ((flag r b 20) 108.9 10) ((flag r b 30) 111.1 15) ((ball) 49.4 0) ((line r) 102.5 -90))\n";
#endif

	SServer_Message_Translator::parse_message( &info ,
						   input ,
						   S_Side_LR::Left_Side ,
						   "test-team" ,
						   true );
#else
	string	input = "(see 0 ((Goal) 2.5 180) ((goal r) 102.5 0) ((flag c) 49.9 0) ((flag r t) 107.8 -18) ((flag r b) 107.8 18) ((flag p l c) 14 0 -0 0) ((flag p r t) 88.2 -13) ((flag p r c) 85.6 0) ((flag p r b) 88.2 13) ((flag g r t) 102.5 -3) ((flag g r b) 102.5 3) ((flag t r 50) 107.8 -21) ((flag b r 50) 107.8 21) ((flag r t 30) 111.1 -15) ((flag r t 20) 108.9 -10) ((flag r t 10) 107.8 -5) ((flag r 0) 107.8 0) ((flag r b 10) 107.8 5) ((flag r b 20) 108.9 10) ((flag r b 30) 111.1 15) ((ball) 49.4 0) ((line r) 102.5 -90))\n";

	Prof_Stopwatch	sw;

	sw.start();

	int	LOOP = 1000;

	for ( int i = 0  ;  i < LOOP  ;  i ++ )
	{
		SServer_Message_Translator::parse_message(
		  &info , input , S_Side_LR::Left_Side , "test-team" , true );
	}

	sw.stop();

	cout << sw.real().usec() / LOOP << " usec" << endl;
#endif

	if ( info.illegal() )
	{
		cerr << "Unknown format: ["
		     << info.raw_message() << "]" << endl;
	}

	return( 0 );
}
#endif // SSERVER_MESSAGE_TRANSLATOR_TEST




#include  "sserver_message_translator.h"
#include  "ref_count_ptr.h"
#include  <string>
#include  <strstream>
#include  <cstring>
#include  <cfloat>
#include  <cmath>
#include  <cstdio>

using namespace std;

#include  "sserver_io.h"
const	size_t	SServer_Message_Translator::SSERVER_MAX_MESSAGE_LENGTH
			= SServer_IO::SSERVER_MAX_MESSAGE_LENGTH;

string  SServer_Message_Translator::init_command( const string &  team_name ,
						  bool  goalie ,
						  int  major_version ,
						  int  minor_version )
{
	//
	// Send "init" message to server.
	//
	string	send_string = static_cast<string>("(init ") + team_name;

	if ( major_version >= 0 )
	{
		ref_count_ptr<char>	version_string;
		try
		{
			version_string
			    = new char[1024 + SSERVER_MAX_MESSAGE_LENGTH + 1];
		}
		catch( ... )
		{
			cerr << "Can't allocate memory" << endl;
			throw;
		}

		sprintf( version_string.get() , " (version %d.%02d)" ,
						major_version ,
						minor_version );
		send_string += version_string.get();
	}

	if ( goalie )
	{
		send_string += " (goalie)";
	}

	send_string += ")\n";

	return( send_string );
}


string  SServer_Message_Translator::reconnect_command(
					      const string &  team_name ,
					      int  player_number )
{
	bool	bad_player_number = false;

	if ( ! (1 <= player_number
		&& player_number <= static_cast<int>(ELEVEN)) )
	{
		cerr << "bad player number: " << player_number << endl;
		bad_player_number = true;
	}

#ifndef LIB_MEMORY
	strstream	send_string;

	send_string  <<  "(reconnect " << team_name << " "
		     <<  player_number << ")" << endl  << ends;

	return( send_string.str() );
#else
	if ( team_name.length() > SSERVER_MAX_MESSAGE_LENGTH )
	{
		cerr << "teamname too long: \"" << team_name << "\"" << endl;
		return( "" );
	}

	if ( bad_player_number )
	{
		return( "" );
	}

	ref_count_ptr<char>	buf;
	try
	{
		buf = new char[ 1024 + SSERVER_MAX_MESSAGE_LENGTH + 1 ];
	}
	catch( ... )
	{
		cerr << "Can't allocate memory" << endl;
		throw;
	}

	sprintf( buf.get() , "(reconnect %s %d)\n" ,
		 team_name.c_str() , player_number );

	return( buf.get() );
#endif
}


string  SServer_Message_Translator::bye_command()
{
	return( "(bye)\n" );
}


string  SServer_Message_Translator::move_command( double  x ,  double  y )
{
	double		translated_y;
	user_input_to_y( &translated_y , y );

#ifndef LIB_MEMORY
	strstream	send_string;
	send_string.precision( DBL_DIG );

	send_string  <<  "(move " << x << " " << translated_y << ")" << endl
		     <<  ends;

	return( send_string );
#else
	char	buf[1024 + DBL_DIG * 2];
	sprintf( buf , "(move %.*f %.*f)\n" ,
		 DBL_DIG , x , DBL_DIG , translated_y );

	return( buf );
#endif
}


string  SServer_Message_Translator::dash_command( double  power )
{
#ifndef LIB_MEMORY
	strstream	send_string;
	send_string.precision( DBL_DIG );

	send_string  <<  "(dash " << power << ")" << endl  << ends;

	return( send_string );
#else
	char	buf[1024 + DBL_DIG];
	sprintf( buf , "(dash %.*f)\n" , DBL_DIG , power );

	return( buf );
#endif
}


string  SServer_Message_Translator::kick_command( double  power ,
						  double  direction ,
						  bool  use_radian )
{
	double		translated_dir;
	user_input_to_dir( &translated_dir , direction , use_radian );

#ifndef LIB_MEMORY
	strstream	send_string;
	send_string.precision( DBL_DIG );

	send_string  <<  "(kick " << power << " " << translated_dir << ")"
		     <<  endl  << ends;

	return( send_string );
#else
	char	buf[1024 + DBL_DIG * 2];

	sprintf( buf , "(kick %.*f %.*f)\n" ,
		 DBL_DIG , power , DBL_DIG , translated_dir );

	return( buf );
#endif
}

string  SServer_Message_Translator::turn_command( double  moment ,
						  bool  use_radian )
{
	double		translated_moment;
	user_input_to_dir( &translated_moment , moment , use_radian );

#ifndef LIB_MEMORY
	strstream	send_string;
	send_string.precision( DBL_DIG );

	send_string  << "(turn " << translated_moment << ")" << endl  << ends;

	return( send_string );
#else
	char	buf[1024 + DBL_DIG];

	sprintf( buf , "(turn %.*f)\n" , DBL_DIG , translated_moment );

	return( buf );
#endif
}


string  SServer_Message_Translator::say_command( const string &  message )
{
	// no check for message here.
	// message must be consist of [a-zA-Z().+-*/?<>_].
	string	send_string = static_cast<string>("(say ") + message + ")\n";

	return( send_string );
}


string  SServer_Message_Translator::catch_command( double  direction ,
						   bool use_radian )
{
	double		translated_dir;
	user_input_to_dir( &translated_dir , direction , use_radian );

#ifndef LIB_MEMORY
	strstream	send_string;

	send_string  <<  "(catch " << translated_dir << ")" << endl  << ends;

	return( send_string );
#else
	char	buf[1024 + DBL_DIG];

	sprintf( buf , "(catch %.*f)\n" , DBL_DIG , translated_dir );

	return( buf );
#endif
}


string  SServer_Message_Translator::change_view_command(
						View_Angle  angle ,
						View_Quality  quality )
{
	string	angle_string;
	string	quality_string;

	switch( angle )
	{
		case View_Angle::Narrow:	angle_string = "narrow"; break;
		case View_Angle::Normal:	angle_string = "normal"; break;
		case View_Angle::Wide:		angle_string = "wide"  ; break;
	}

	switch( quality )
	{
		case View_Quality::High:	quality_string = "high"; break;
		case View_Quality::Low:		quality_string = "low" ; break;
	}

	string	send_string = static_cast<string>("(change_view ")
				+ angle_string + " " + quality_string + ")\n";

	return( send_string );
}


string  SServer_Message_Translator::sense_body_command()
{
	return( "(sense_body)" );
}


string  SServer_Message_Translator::turn_neck_command( double  direction ,
						       bool  use_radian )
{
	double		translated_dir;
	user_input_to_dir( &translated_dir , direction , use_radian );

#ifndef LIB_MEMORY
	strstream	send_string;

	send_string  <<  "(turn_neck "
		     <<  translated_dir << ")" << endl  << ends;

	return( send_string );
#else
	char	buf[1024 + DBL_DIG];

	sprintf( buf , "(turn_neck %.*f)\n" , DBL_DIG , translated_dir );

	return( buf );
#endif
}


#if 1
//
// coach commands
//
string  SServer_Message_Translator::look_command()
{
	return( "(look)" );
}

string  SServer_Message_Translator::check_ball_command()
{
	return( "(check_ball)" );
}

string  SServer_Message_Translator::ear_command( bool  on_off )
{
	string	send_string = static_cast<string>("(err ")
		+ (on_off ? "on" : "off") + ")\n";

	return( send_string );
}

#if 0
string  SServer_Message_Translator::change_mode_command( Play_Mode  mode )
{
	string	send_string = (string)"(change_mode "
		+ play_mode_to_string( mode , our_side ) + ")\n";

	return( send_string );
}
#endif
#endif


void   SServer_Message_Translator::parse_init_message( Game_Info *  g_info ,
						       const  string &  mes )
{
	char			side;
	int			player_number;
	ref_count_ptr<char>	play_mode;
	try
	{
		play_mode = new char[ SSERVER_MAX_MESSAGE_LENGTH + 1 ];
	}
	catch( ... )
	{
		cerr << "Can't allocate memory" << endl;
		throw;
	}

	if ( sscanf( mes.c_str() , "(init %c %d %[a-z_])" ,
		     &side , &player_number , play_mode.get() ) != 3
	  || ! (side == 'l' || 'r') )
	{
		cerr << "\"" << mes << "\" : ";
		cerr << "Unexpected initial message from server." << endl;

		g_info -> our_side         = S_Side_LR::Unknown;
		g_info -> my_player_number = -1;
		g_info -> play_mode        = Play_Mode::Unknown;
	}
	else
	{
		g_info -> our_side
			= ((side == 'l') ?
			   S_Side_LR::Left_Side : S_Side_LR::Right_Side);
		g_info -> my_player_number = player_number;
		g_info -> play_mode = string_to_play_mode(
						  play_mode.get() ,
						  g_info -> our_side );
	}
}


void   SServer_Message_Translator::
		parse_reconnect_message( Game_Info *  g_info ,
					 const  string &  mes ,
					 int  player_number )
{
	char		side;
	ref_count_ptr<char>	play_mode;
	try
	{
		play_mode = new char[ SSERVER_MAX_MESSAGE_LENGTH + 1 ];
	}
	catch( ... )
	{
		cerr << "Can't allocate memory" << endl;
		throw;
	}

	if ( sscanf( mes.c_str() , "(reconnect %c %[a-z_])" ,
		     &side , play_mode.get() ) != 2
	  || ! (side == 'l' || 'r') )
	{
		cerr << "\"" << mes << "\" : ";
		cerr << "Unexpected reconnect message from server." << endl;

		g_info -> our_side         = S_Side_LR::Unknown;
		g_info -> my_player_number = -1;
		g_info -> play_mode        = Play_Mode::Unknown;
	}
	else
	{
		g_info -> our_side
			= ((side == 'l') ?
			   S_Side_LR::Left_Side : S_Side_LR::Right_Side);
		g_info -> my_player_number = player_number;
		g_info -> play_mode = string_to_play_mode(
						  play_mode.get() ,
						  g_info -> our_side );
	}
}


Play_Mode  SServer_Message_Translator::string_to_play_mode(
						   const string &  mode ,
						   S_Side_LR  our_side )
{
	if ( mode  ==  "before_kick_off" )
	{
		return( Play_Mode::Before_Kick_Off );
	}
	else if ( mode  ==  "play_on" )
	{
		return( Play_Mode::Play_On );
	}
	else if ( mode  ==  "time_over" )
	{
		return( Play_Mode::Time_Over );
	}


	string	l_or_r;
	string	mode_base;

	if ( mode.length() < 2
	 ||  our_side == S_Side_LR::Unknown )
	{
		return( Play_Mode::Unknown );
	}

	l_or_r    = mode.substr( mode.length() - 2 , 2 );
	mode_base = mode.substr( 0 , mode.length() - 2 );

	if ( ! (l_or_r == "_l" || l_or_r == "_r" ) )
	{
		return( Play_Mode::Unknown );
	}

	S_Side	side;
	if ( (l_or_r == "_l" && our_side == S_Side_LR::Left_Side)
	  || (l_or_r == "_r" && our_side == S_Side_LR::Right_Side) )
	{
		side = S_Side::Our_Side;
	}
	else
	{
		side = S_Side::Opponent_Side;
	}

	if ( mode_base == "kick_off" )
	{
		if ( side == S_Side::Our_Side )
		{
			return( Play_Mode::Our_Kick_Off );
		}
		else
		{
			return( Play_Mode::Opponent_Kick_Off );
		}
	}
	else if ( mode_base == "kick_in" )
	{
		if ( side == S_Side::Our_Side )
		{
			return( Play_Mode::Our_Kick_In );
		}
		else
		{
			return( Play_Mode::Opponent_Kick_In );
		}
	}
	else if ( mode_base == "free_kick" )
	{
		if ( side == S_Side::Our_Side )
		{
			return( Play_Mode::Our_Free_Kick );
		}
		else
		{
			return( Play_Mode::Opponent_Free_Kick );
		}
	}
	else if ( mode_base == "corner_kick" )
	{
		if ( side == S_Side::Our_Side )
		{
			return( Play_Mode::Our_Corner_Kick );
		}
		else
		{
			return( Play_Mode::Opponent_Corner_Kick );
		}
	}
	else if ( mode_base == "goal_kick" )
	{
		if ( side == S_Side::Our_Side )
		{
			return( Play_Mode::Our_Goal_Kick );
		}
		else
		{
			return( Play_Mode::Our_Goal );
		}
	}
	else if ( mode_base == "goal_kick" )
	{
		if ( side == S_Side::Our_Side )
		{
			return( Play_Mode::Our_Goal_Kick );
		}
		else
		{
			return( Play_Mode::Opponent_Goal_Kick );
		}
	}
	else if ( mode_base == "goal" )
	{
		if ( side == S_Side::Our_Side )
		{
			return( Play_Mode::Our_Goal );
		}
		else
		{
			return( Play_Mode::Opponent_Goal );
		}
	}
	else
	{
		return( Play_Mode::Unknown );
	}
}


void   SServer_Message_Translator::parse_message(
					Information_from_Server *  info ,
					const string &  mes ,
					S_Side_LR  our_side ,
					const string &  team_name ,
					bool  use_radian )
{
	info -> reset_info();
	info -> set_time( -1 );
	info -> set_raw_message( mes );

	Information_from_Server	illegal_info;
	illegal_info.reset_info();
	illegal_info.set_time( -1 );
	illegal_info.set_raw_message( mes );

	if ( mes.length() == 0 )
	{
		info -> set_no_info();
		return;
	}

#if 0
	// TTT
	cout  <<  "info["  <<  mes  <<  "]"  <<  endl;
#endif

	if ( strncmp( mes.c_str() ,"(hear " ,
		      strlen("(hear ") ) == 0 )
	{
		// analyze audio and whistle info.
		if ( ! analyze_audio_info_brief( info , mes ,
						 our_side , use_radian ) )
		{
			info -> reset_info();
		}

		return;
	}
#ifndef LISP_LEX_PARSE
	else if ( strncmp( mes.c_str() ,"(sense_body " ,
			   strlen("(sense_body ") ) == 0 )
	{
		// analyze body info.
		if ( ! analyze_body_info_brief( info , mes , use_radian ) )
		{
			info -> reset_info();
		}

		return;
	}
	else if ( strncmp( mes.c_str() ,"(see " ,
			   strlen("(see ") ) == 0 )
	{
		// analyze sight info.
		if ( ! analyze_sight_info_brief( info , mes ,
						 our_side , team_name ,
						 use_radian ) )
		{
			info -> reset_info();
		}

		return;
	}
#endif


	Lisp_Lexical_Analyser	lisp_lex;
	if ( ! lisp_lex.analyze( mes ) )
	{
		*info = illegal_info;
		return;
	}
	Lisp_Lexical_Object	input = lisp_lex.result();

	// Make sure each input format is this.
	//	(% % ...)
	// % : symbol
	if ( ! (   input.list.size() == 1
		&& input.list[0].type == Lisp_Lexical_Object::List
		&& input.list[0].has_right_paren == true
		&& input.list[0].list.size() >= 2
		&& input.list[0].list[0].type == Lisp_Lexical_Object::Symbol
		&& input.list[0].list[1].type == Lisp_Lexical_Object::Symbol) )
	{
		return;
	}

	int	info_time;
	if ( input.list[0].list[0].symbol == "error" )
	{
		analyze_error_info( info , input.list[0] );
		return;
	}
	else if ( ! str_to_int( &info_time , input.list[0].list[1].symbol ) )
	{
		*info = illegal_info;
		return;
	}

	info -> set_time( info_time );
	illegal_info.set_time( info_time );

	string	info_type = input.list[0].list[0].symbol;
#ifdef LISP_LEX_PARSE
	if ( info_type == "see" )
	{
		// analyze sight info.
		analyze_sight_info( info , input.list[0] ,
				    our_side , team_name , use_radian );
	}
#else
	if ( 0 )
	{
	}
#endif
#ifdef LISP_LEX_PARSE
	else if ( info_type == "sense_body" )
	{
		// analyze body info.
		analyze_body_info( info , input.list[0] , use_radian );
	}
#endif
	else if ( info_type == "debug" )
	{
		// analyze debug info.
		analyze_debug_info( info , input.list[0] );
	}
	else
	{
		*info = illegal_info;
	}
}


#ifdef LISP_LEX_PARSE
// only for SServer_Message_Translator::analyze_sight_info()
bool   SServer_Message_Translator::analyze_sight_info_check_format(
					   const Lisp_Lexical_Object &  obj )
{
	// Make sure each input entry's format is this.
	//	     ((...) *)
	//	  || ((...) * *)
	//	  || ((...) * * * *)
	//	  || ((...) * * * * *)
	//	  || ((...) * * * * * * *)
	if ( obj.type != Lisp_Lexical_Object::List
	 ||   (    obj.list.size() != 2
	        && obj.list.size() != 3
	        && obj.list.size() != 5
	        && obj.list.size() != 6
	        && obj.list.size() != 7 )
	 ||  obj.list[0].type != Lisp_Lexical_Object::List )
	{
		return( false );
	}

	// Make sure each input entry's format is this.
	//	     ((% ...) %)
	//	  || ((% ...) % %)
	//	  || ((% ...) % % % %)
	//	  || ((% ...) % % % % %)
	//	  || ((% ...) % % % % % % %)
	for( unsigned int  i = 0  ;  i  < obj.list[0].list.size()  ;  i ++ )
	{
		if ( obj.list[0].list[i].type
		     != Lisp_Lexical_Object::Symbol )
		{
			return( false );
		}
	}

	// Make sure each input entry's format is this.
	//	     ((% ...) %)
	//	  || ((% ...) % %)
	//	  || ((% ...) % % % %)
	//	  || ((% ...) % % % % %)
	//	  || ((% ...) % % % % % % %)
	for( unsigned int  i = 1  ;  i  < obj.list.size()  ;  i ++ )
	{
		if ( obj.list[i].type != Lisp_Lexical_Object::Symbol )
		{
			return( false );
		}
	}

	return( true );
}

// only for SServer_Message_Translator::analyze_sight_info()
bool   SServer_Message_Translator::analyze_sight_info_get_relative(
			SObject_Locational_Info_from_Server *  relative ,
			const Lisp_Lexical_Object &  obj ,
			bool  use_radian )
{
	//
	// get locational information
	//
	relative -> has_distance       = false;
	relative -> has_direction      = false;
	relative -> has_d_distance     = false;
	relative -> has_d_direction    = false;
	relative -> has_body_direction = false;
	relative -> has_face_direction = false;

	relative -> distance       = 0.0;
	relative -> direction      = 0.0;
	relative -> d_distance     = 0.0;
	relative -> d_direction    = 0.0;
	relative -> body_direction = 0.0;
	relative -> face_direction = 0.0;


	if ( obj.list.size() >= 8 )
	{
		return( false );
	}

	if ( obj.list.size() >= 7 )
	{
		relative -> has_face_direction = true;
		if ( ! server_str_to_dir( &(relative -> face_direction) ,
					  obj.list[6].symbol ,
					  use_radian ) )
		{
			return( false );
		}
	}

	if ( obj.list.size() >= 6 )
	{
		relative -> has_body_direction = true;
		if ( ! server_str_to_dir( &(relative -> body_direction) ,
					  obj.list[5].symbol ,
					  use_radian ) )
		{
			return( false );
		}
	}

	if ( obj.list.size() >= 5 )
	{
		relative -> has_d_direction = true;
		relative -> has_d_distance  = true;

		if ( ! server_str_to_dir( &(relative -> d_direction) ,
					  obj.list[4].symbol ,
					  use_radian )
		  || ! str_to_real( &(relative -> d_distance) ,
				    obj.list[3].symbol ) )
		{
			return( false );
		}
	}

	if ( obj.list.size() >= 3 )
	{
		relative -> has_direction = true;
		relative -> has_distance  = true;

		if ( ! server_str_to_dir( &(relative -> direction) ,
					  obj.list[2].symbol ,
					  use_radian )
		  || ! str_to_real( &(relative -> distance) ,
				    obj.list[1].symbol ) )
		{
			return( false );
		}
	}
	else // if ( obj.list.size() == 2 )
	{
		relative -> has_direction = true;

		if ( ! server_str_to_dir( &relative -> direction ,
					  obj.list[1].symbol ,
					  use_radian ) )
		{
			return( false );
		}
	}

	return( true );
}

#include  "fixed_sobject_location.h"
void   SServer_Message_Translator::analyze_sight_info(
					    Information_from_Server * info ,
					    Lisp_Lexical_Object & input ,
					    S_Side_LR  our_side ,
					    const string &  team_name ,
					    bool  use_radian )
{
	static	Fixed_SObject_Location_Translator	obj_to_location;

	// Make sure input format is this.
	//	(* * ...)
	if ( input.list.size()  <  2 )
	{
		info -> reset_info();
		return;
	}


	Sight_Info_from_Server	sight_info;

	for ( unsigned int  i = 2  ;  i < input.list.size()  ;  i ++ )
	{
		Lisp_Lexical_Object &	obj = input.list[i];

		if ( ! analyze_sight_info_check_format( obj ) )
		{
			info -> reset_info();
			return;
		}

		SObject_Locational_Info_from_Server	relative;
		if ( ! analyze_sight_info_get_relative( &relative ,
							obj ,
							use_radian ) )
		{
			info -> reset_info();
			return;
		}

		//
		// Get object identification and set to Sight_Info_from_Server
		//

		Lisp_Lexical_Object &	obj_ident = obj.list[0];
		string	obj_type = obj_ident.list[0].symbol;

		if ( obj_type == "flag" || obj_type == "Flag" )
		{
			if ( ! (   (2 <= obj_ident.list.size()
				    &&   obj_ident.list.size() <= 4)
			        || (obj_type == "Flag"
				    && obj_ident.list.size() == 1) ) )
			{
				info -> reset_info();
				return;
			}

			Flag_Info_from_Server	flag_info;
			flag_info.relative = relative;
			flag_info.relative.in_sight = (obj_type == "flag");

			obj_to_location.get_location(
				      &flag_info.entity.location ,
				      obj_ident , our_side );

			sight_info.flag.push_back( flag_info );
		}
		else if ( obj_type == "player" || obj_type == "Player" )
		{
			Player_Info_from_Server	player_info;
			player_info.relative = relative;
			player_info.relative.in_sight = (obj_type == "player");

			if ( obj_type == "player" )
			{
				if ( ! (obj_ident.list.size() <= 3) )
				{
					info -> reset_info();
					return;
				}

				if ( obj_ident.list.size() < 2 )
				{
					player_info.entity.side
						= S_Side::Unknown;
				}
				else if ( obj_ident.list[1].symbol
					  == team_name )
				{
					player_info.entity.side
						= S_Side::Our_Side;
				}
				else
				{
					player_info.entity.side
						= S_Side::Opponent_Side;
				}

				// EEE: 1 <= player_number must <= ELEVEN
				if ( obj_ident.list.size() < 3 )
				{
					player_info.entity.player_number = -1;
				}
				else
				{
					str_to_int(
					   &player_info.entity.player_number ,
					   obj_ident.list[2].symbol );

					if (! (1 <= player_info.entity
						     .player_number
					        &&  player_info.entity
						     .player_number
						<= static_cast<int>(ELEVEN)))
					{
						info -> reset_info();
						return;
					}
				}
			}
			else // if ( obj_type == "Player" )
			{
				if ( obj_ident.list.size() != 1 )
				{
					info -> reset_info();
					return;
				}

				player_info.entity.side = S_Side::Unknown;
				player_info.entity.player_number = -1;
			}

			sight_info.player.push_back( player_info );
		}
		else if ( obj_type == "ball"  ||  obj_type == "Ball" )
		{
			if ( obj_ident.list.size() != 1 )
			{
				info -> reset_info();
				return;
			}

			Ball_Info_from_Server	ball_info;
			ball_info.relative = relative;
			ball_info.relative.in_sight = (obj_type == "ball");

			sight_info.ball.push_back( ball_info );
		}
		else if ( obj_type == "goal" || obj_type == "Goal" )
		{
			Goal_Info_from_Server	goal_info;
			goal_info.relative = relative;
			goal_info.relative.in_sight = (obj_type == "goal");

			if ( obj_type == "goal" )
			{
				const string	side_str
						  = obj_ident.list[1].symbol;
				if ( ! ( obj_ident.list.size() == 2
				      && (side_str == "l"
				       || side_str == "r" ) ) )
				{
					info -> reset_info();
					return;
				}

				obj_to_location.get_location(
						&goal_info.entity.location ,
						obj_ident , our_side );

				if ( (side_str == "l"
					&& our_side == S_Side_LR::Left_Side)
				  || (side_str == "r"
					&& our_side == S_Side_LR::Right_Side) )
				{
					goal_info.entity.side
						= S_Side::Our_Side;
				}
				else
				{
					goal_info.entity.side
						= S_Side::Opponent_Side;
				}
			}
			else // if ( obj_type == "Goal" )
			{
				if ( ! (obj_ident.list.size() == 1) )
				{
					info -> reset_info();
					return;
				}

				goal_info.entity.side     = S_Side::Unknown;
				goal_info.entity.location.set( D2_Vector::XY ,
							       0.0 , 0.0 );
			}
			sight_info.goal.push_back( goal_info );
		}
		else if ( obj_type == "line" )
		{
			if ( obj_ident.list.size() != 2 )
			{
				info -> reset_info();
				return;
			}

			Line_Info_from_Server	line_info;
			line_info.relative = relative;
			line_info.relative.in_sight = true;

			const string	ln_str = obj_ident.list[1].symbol;

			if ( (ln_str == "l"
				  && our_side == S_Side_LR::Left_Side)
			  || (ln_str == "r"
				  && our_side == S_Side_LR::Right_Side) )
			{
				line_info.entity.which_line
				 = SObject_Line_Identifier::Our_Goal_Line;
			}
			else if ( (ln_str == "l"
				       && our_side == S_Side_LR::Right_Side)
			       || (ln_str == "r"
				       && our_side == S_Side_LR::Left_Side) )
			{
				line_info.entity.which_line
				 = SObject_Line_Identifier::Opponent_Goal_Line;
			}
			else if ( (ln_str == "b"
				       && our_side == S_Side_LR::Left_Side)
			       || (ln_str == "t"
				       && our_side == S_Side_LR::Right_Side) )
			{
				line_info.entity.which_line
				 = SObject_Line_Identifier::Left_Wing_Line;
			}
			else if ( (ln_str == "b"
				       && our_side == S_Side_LR::Right_Side)
			       || (ln_str == "t"
				       && our_side == S_Side_LR::Left_Side) )
			{
				line_info.entity.which_line
				 = SObject_Line_Identifier::Right_Wing_Line;
			}
			else
			{
				info -> reset_info();
				return;
			}

			sight_info.line.push_back( line_info );
		}
		else
		{
			info -> reset_info();
			return;
		}
	}

	info -> set_info( sight_info );
}
#endif




#ifndef LISP_LEX_PARSE
// XXX
//   Now, the follow code is almost same as analyze_sight_info*
//   But this will be faster in the future.

// only for SServer_Message_Translator::analyze_sight_info_brief()

#include  "fixed_sobject_location.h"
bool   SServer_Message_Translator::analyze_sight_info_brief_get_obj_info(
			Sight_Info_from_Server &  sight_info ,
			int  obj_ident_size ,
			char **  obj_ident ,
			const SObject_Locational_Info_from_Server &  relative ,
			S_Side_LR  our_side ,
			const string &  team_name )
{
	static	Fixed_SObject_Location_Translator	obj_to_location;

	if ( obj_ident_size <= 0 )
	{
		return( false );
	}

	const string	obj_type = obj_ident[0];

	if ( obj_type == "flag" || obj_type == "Flag" )
	{
		if ( ! (    (2 <= obj_ident_size &&  obj_ident_size <= 4)
			 || (obj_type == "Flag" && obj_ident_size == 1)  ) )
		{
			return( false );
		}

		Flag_Info_from_Server	flag_info;
		flag_info.relative = relative;
		flag_info.relative.in_sight = (obj_type == "flag");
		obj_to_location.get_location( &flag_info.entity.location ,
					      obj_ident_size , obj_ident ,
					      our_side );

		sight_info.flag.push_back( flag_info );
	}
	else if ( obj_type == "player" || obj_type == "Player" )
	{
		Player_Info_from_Server	player_info;
		player_info.relative = relative;
		player_info.relative.in_sight = (obj_type == "player");

		if ( obj_type == "player" )
		{
			if ( ! (obj_ident_size <= 3) )
			{
				return( false );
			}

			if ( obj_ident_size < 2 )
			{
				player_info.entity.side = S_Side::Unknown;
			}
			else if ( obj_ident[1] == team_name )
			{
				player_info.entity.side = S_Side::Our_Side;
			}
			else
			{
				player_info.entity.side
					= S_Side::Opponent_Side;
			}

			// EEE: 1 <= player_number must <= ELEVEN
			if ( obj_ident_size < 3 )
			{
				player_info.entity.player_number = -1;
			}
			else
			{
				str_to_int( &player_info.entity.player_number ,
					    obj_ident[2] );

				if (! (1 <= player_info.entity.player_number
				       &&  player_info.entity.player_number
				       <= static_cast<int>(ELEVEN)))
				{
					return( false );
				}
			}
		}
		else // if ( obj_type == "Player" )
		{
			if ( obj_ident_size != 1 )
			{
				return( false );
			}

			player_info.entity.side = S_Side::Unknown;
			player_info.entity.player_number = -1;
		}

		sight_info.player.push_back( player_info );
	}
	else if ( obj_type == "ball"  ||  obj_type == "Ball" )
	{
		if ( obj_ident_size != 1 )
		{
			return( false );
		}

		Ball_Info_from_Server	ball_info;
		ball_info.relative = relative;
		ball_info.relative.in_sight = (obj_type == "ball");

		sight_info.ball.push_back( ball_info );
	}
	else if ( obj_type == "goal" || obj_type == "Goal" )
	{
		Goal_Info_from_Server	goal_info;
		goal_info.relative = relative;
		goal_info.relative.in_sight = (obj_type == "goal");

		if ( obj_type == "goal" )
		{
			const string	side_str = obj_ident[1];
			if ( ! ( obj_ident_size == 2
				 && (side_str == "l"
				     || side_str == "r" ) ) )
			{
				return( false );
			}

			obj_to_location.get_location(
					     &goal_info.entity.location ,
					     obj_ident_size , obj_ident ,
					     our_side );

			if ( (side_str == "l"
			      && our_side == S_Side_LR::Left_Side)
			     || (side_str == "r"
				 && our_side == S_Side_LR::Right_Side) )
			{
				goal_info.entity.side = S_Side::Our_Side;
			}
			else
			{
				goal_info.entity.side = S_Side::Opponent_Side;
			}
		}
		else // if ( obj_type == "Goal" )
		{
			if ( ! (obj_ident_size == 1) )
			{
				return( false );
			}

			goal_info.entity.side = S_Side::Unknown;
			goal_info.entity.location.set( D2_Vector::XY ,
						       0.0 , 0.0 );
		}
		sight_info.goal.push_back( goal_info );
	}
	else if ( obj_type == "line" )
	{
		if ( obj_ident_size != 2 )
		{
			return( false );
		}

		Line_Info_from_Server	line_info;
		line_info.relative = relative;
		line_info.relative.in_sight = true;

		const string	ln_str = obj_ident[1];

		if ( (ln_str == "l"
		      && our_side == S_Side_LR::Left_Side)
		     || (ln_str == "r"
			 && our_side == S_Side_LR::Right_Side) )
		{
			line_info.entity.which_line
				= SObject_Line_Identifier::Our_Goal_Line;
		}
		else if ( (ln_str == "l"
			   && our_side == S_Side_LR::Right_Side)
			  || (ln_str == "r"
			      && our_side == S_Side_LR::Left_Side) )
		{
			line_info.entity.which_line
				= SObject_Line_Identifier::Opponent_Goal_Line;
		}
		else if ( (ln_str == "b"
			   && our_side == S_Side_LR::Left_Side)
			  || (ln_str == "t"
			      && our_side == S_Side_LR::Right_Side) )
		{
			line_info.entity.which_line
				= SObject_Line_Identifier::Left_Wing_Line;
		}
		else if ( (ln_str == "b"
			   && our_side == S_Side_LR::Right_Side)
			  || (ln_str == "t"
			      && our_side == S_Side_LR::Left_Side) )
		{
			line_info.entity.which_line
				= SObject_Line_Identifier::Right_Wing_Line;
		}
		else
		{
			return( false );
		}

		sight_info.line.push_back( line_info );
	}
	else
	{
		return( false );
	}

	return( true );
}


// XXX
// only for SServer_Message_Translator::analyze_sight_info_brief()
bool   SServer_Message_Translator::analyze_sight_info_brief_get_relative(
		 SObject_Locational_Info_from_Server *  relative ,
		 int  n_data ,  double  data[] , bool  use_radian )
{
	//
	// get locational information
	//
	relative -> has_distance       = false;
	relative -> has_direction      = false;
	relative -> has_d_distance     = false;
	relative -> has_d_direction    = false;
	relative -> has_body_direction = false;
	relative -> has_face_direction = false;

	relative -> distance       = 0.0;
	relative -> direction      = 0.0;
	relative -> d_distance     = 0.0;
	relative -> d_direction    = 0.0;
	relative -> body_direction = 0.0;
	relative -> face_direction = 0.0;


	if ( n_data >= 7 )
	{
		return( false );
	}

	if ( n_data >= 6 )
	{
		relative -> has_face_direction = true;
		server_real_to_dir( &(relative -> face_direction) ,
				    data[5] , use_radian );
	}

	if ( n_data >= 5 )
	{
		relative -> has_body_direction = true;
		server_real_to_dir( &(relative -> body_direction) ,
				    data[4] , use_radian );
	}

	if ( n_data >= 4 )
	{
		relative -> has_d_direction = true;
		relative -> has_d_distance  = true;

		server_real_to_dir( &(relative -> d_direction) ,
				    data[3] , use_radian );
		relative -> d_distance = data[2];
	}

	if ( n_data >= 2 )
	{
		relative -> has_direction = true;
		relative -> has_distance  = true;

		server_real_to_dir( &(relative -> direction) ,
				    data[1] , use_radian );
		relative -> distance = data[0];
	}
	else // if ( n_data == 1 )
	{
		relative -> has_direction = true;

		server_real_to_dir( &relative -> direction ,
				    data[0] , use_radian );
	}

	return( true );
}

bool   SServer_Message_Translator::analyze_sight_info_brief(
				    Information_from_Server *  info ,
				    const string &  mes ,
				    S_Side_LR  our_side ,
				    const string &  team_name ,
				    bool  use_radian )
{
	static	Fixed_SObject_Location_Translator	obj_to_location;
	Sight_Info_from_Server	sight;

	int	info_time;
	char	next_char;
	int	start_point;

	if ( sscanf( mes.c_str() ,
		     "(see %d %n%c" ,
		     &info_time , &start_point , &next_char ) != 2 )
	{
		return( false );
	}

	info -> set_time( info_time );

	if ( next_char == ')' )
	{
		info -> set_info( sight );
		return( true );
	}

	if ( next_char != '(' )
	{
		return( false );
	}


	const char *	ptr = mes.c_str() + start_point;

	for(;;)
	{
		// XXX: magic number 256
		char	oid_entity[4][256 + 1];
		char *	oid[4];
		int	oid_n[4];
		int	oid_n_match;

		for ( size_t  i = 0  ;  i < 4  ;  i ++ )
		{
			oid[i] = oid_entity[i];
		}


		// XXX: magic number 256
		oid_n_match = sscanf( ptr ,
				      " ((%256[^() ] %n%256[^() ] %n"
				         "%256[^() ] %n%256[^() ] %n" ,
				      oid[0] , oid_n + 0 ,
				      oid[1] , oid_n + 1 ,
				      oid[2] , oid_n + 2 ,
				      oid[3] , oid_n + 3 );

		if ( oid_n_match <= 0 )
		{
			return( false );
		}

		if ( *(ptr += oid_n[oid_n_match - 1]) != ')' )
		{
			return( false );
		}

		ptr ++;


		double	rel[6];
		int	rel_n[6];
		int	rel_n_match;

		rel_n_match = sscanf( ptr ,
				      "%lf%n%lf%n%lf%n%lf%n%lf%n%lf%n" ,
				      &rel[0] , &rel_n[0] ,
				      &rel[1] , &rel_n[1] ,
				      &rel[2] , &rel_n[2] ,
				      &rel[3] , &rel_n[3] ,
				      &rel[4] , &rel_n[4] ,
				      &rel[5] , &rel_n[5] );

		if ( rel_n_match <= 0 )
		{
			return( false );
		}

		SObject_Locational_Info_from_Server	relative;

		if ( ! analyze_sight_info_brief_get_relative( &relative ,
							      rel_n_match ,
							      rel ,
							      use_radian ) )
		{
			return( false );
		}


		if ( *(ptr += rel_n[rel_n_match - 1]) != ')' )
		{
			return( false );
		}

		ptr ++;

		if ( ! analyze_sight_info_brief_get_obj_info(
							sight ,
							oid_n_match ,
							oid ,
							relative ,
							our_side ,
							team_name ) )
		{
			return( false );
		}

		if ( *ptr == ')' )
		{
			ptr ++;

			if ( strcmp( ptr , "\n" ) != 0
			 &&  strcmp( ptr , "" )   != 0 )
			{
				return( false );
			}
			else
			{
				break;
			}
		}
	}

	info -> set_info( sight );

	return( true );
}
#endif



bool   SServer_Message_Translator::analyze_audio_info_brief(
					    Information_from_Server * info ,
					    const string &  mes ,
					    S_Side_LR  our_side ,
					    bool  use_radian )
{
	int	info_time;

	ref_count_ptr<char>	from;
	from = new char[SSERVER_MAX_MESSAGE_LENGTH + 1];

	int	n;

	{
		static	bool	initialized = false;
		static	char	format[SSERVER_MAX_MESSAGE_LENGTH + 1];

		if ( ! initialized )
		{
			sprintf( format ,
				 "(hear %%d %%%ds %%n" ,
				 static_cast<int>(SSERVER_MAX_MESSAGE_LENGTH)
				 );
		}

		if ( sscanf( mes.c_str() , format ,
			     &info_time , from.get() , &n ) != 2 )
		{
			return( false );
		}
	}


	info -> set_time( info_time );


	char *	m = from.get() + n;
	size_t	m_len = strlen( m );

	if ( m_len >= 1  &&  m[ m_len - 1 ] == '\n' )
	{
		m[ m_len - 1 ] = '\0';
		m_len --;
	}

	if ( m_len < 1  ||  m[ m_len - 1 ] != ')' )
	{
		return( false );
	}
	m[ m_len - 1 ] = '\0';


	const string	message( m );

	if ( strcmp( from.get() , "referee" ) == 0 )
	{
		Whistle_Info_from_Server	wi;
		wi.type = Judgement_Type::Unknown;
		wi.play_mode = Play_Mode::Unknown;
		wi.point = 0;
		wi.side = S_Side::Unknown;
		wi.player_number = -1;

		Play_Mode	play_mode;
		play_mode = SServer_Message_Translator::string_to_play_mode(
							message , our_side );

		if ( play_mode != Play_Mode::Unknown )
		{
			wi.type = Judgement_Type::One_of_Play_Modes;
			wi.play_mode = play_mode;
		}
		else if ( message == "half_time" )
		{
			wi.type = Judgement_Type::Half_Time;
		}
		else if ( message == "time_up" )
		{
			wi.type = Judgement_Type::Time_Up;
		}
		else if ( message == "time_up_without_a_team" )
		{
			wi.type = Judgement_Type::
				      Time_Up_Without_A_Team;
		}
		else if ( message == "time_extended" )
		{
			wi.type = Judgement_Type::Time_Extended;
		}
		else if ( message.length() == strlen("goalie_catch_ball_?")
		       && (   message[strlen("goalie_catch_ball_")] == 'l'
			   || message[strlen("goalie_catch_ball_")] == 'r' ) )
		{
			wi.type = Judgement_Type::Goalie_Catch_Ball;
			wi.side
			  = lr_to_side( message[strlen("goalie_catch_ball_")] ,
					our_side );
		}
		else if ( message.length() >= strlen("goal_?_?")
		      &&  message.substr(0 , strlen("goal_")) == "goal_"
		      &&  (   message[strlen("goal_")] == 'l'
			   || message[strlen("goal_")] == 'r' )
		      &&  message[strlen("goal_") + 1] == '_' )
		{
			wi.type = Judgement_Type::Goal;
			wi.side = lr_to_side( message[strlen("goal_")] ,
					      our_side );
			if ( !(str_to_int( &wi.point ,
					   message.substr(
						     strlen("goal_?_")) )) )
			{
				info -> reset_info();
			}
		}
		else if ( message.length() >= strlen("foul_?")
		      &&  message.substr(0 , strlen("foul_")) == "foul_"
		      &&  (message[strlen("foul_")] == 'l'
			|| message[strlen("foul_")] == 'r' ) )
		{
			wi.type = Judgement_Type::Foul;
			wi.side = lr_to_side( message[strlen("foul_")] ,
					      our_side );

			if ( message.length() >= strlen("foul_?_" ) )
			{
				if ( message[strlen("foul_") + 1] != '_'
				 || !(str_to_int( &wi.player_number ,
					message.substr(strlen("foul_?_")) )) )
				{
					info -> reset_info();
				}
			}
			else
			{
				wi.player_number = -1;
			}

		}
		else if ( message == "drop_ball" )
		{
			wi.type = Judgement_Type::Drop_Ball;
		}
		else if ( message.length() >= strlen("offside_?")
		      &&  message.substr(0 , strlen("offside_")) == "offside_"
		      &&  (message[strlen("offside_")] == 'l'
			|| message[strlen("offside_")] == 'r' ) )
		{
			wi.type = Judgement_Type::Offside;
			wi.side = lr_to_side( message[strlen("offside_")] ,
					      our_side );
		}
		else
		{
			return( false );
		}

		info -> set_info( wi );
	}
	else
	{
		Audio_Info_from_Server	au;

		au.message = message;

		if ( strcmp( from.get() , "self" ) == 0 )
		{
			au.sender    = Audio_Info_from_Server::ST_Self;
			au.direction = 0.0;
		}
		else
		{
			au.sender = Audio_Info_from_Server::ST_Player;
			if ( ! server_str_to_dir( &au.direction , from.get() ,
						  use_radian ) )
			{
				return( false );
			}
		}

		info -> set_info( au );
	}

	return( true );
}



void   SServer_Message_Translator::analyze_body_info(
					      Information_from_Server * info ,
					      Lisp_Lexical_Object & input ,
					      bool  use_radian )
{
	//
	// Format Check
	//
	// Make sure input format is this.
	//	(* * (view_mode % %)
	//	     (stamina % %)
	//	     (speed %)
	//	     (kick %)
	//	     (dash %)
	//	     (turn %)
	//	     (say %))
	// * : list or symbol
	// % : symbol

	// start
	//
	struct  Sense_Body_Format
	{
		string		parameter;
		unsigned int	n_arguments;
	};

	static const  size_t		n_entry_ver4 = 7;
	static const  Sense_Body_Format	format_ver4[n_entry_ver4] =
	{
		{ "view_mode" , 2 },
		{ "stamina"   , 2 },
		{ "speed"     , 1 },
		{ "kick"      , 1 },
		{ "dash"      , 1 },
		{ "turn"      , 1 },
		{ "say"       , 1 }
	};

	static const  size_t		n_entry_ver5 = 9;
	static const  Sense_Body_Format	format_ver5[n_entry_ver5] =
	{
		{ "view_mode" , 2 },
		{ "stamina"   , 2 },
		{ "speed"     , 1 },
		{ "head_angle", 1 },
		{ "kick"      , 1 },
		{ "dash"      , 1 },
		{ "turn"      , 1 },
		{ "say"       , 1 },
		{ "turn_neck" , 1 }
	};

	// Make sure input format is this.
	//	(* * * * * * * * *) || (* * * * * * * * * * *)
	int	sense_body_version;
	size_t	n_entry;
	const  Sense_Body_Format *	format;
	if ( input.list.size() == (2 + n_entry_ver4) )
	{
		sense_body_version = 4;
		format  = format_ver4;
		n_entry = n_entry_ver4;
	}
	else if ( input.list.size() == (2 + n_entry_ver5) )
	{
		sense_body_version = 5;
		format  = format_ver5;
		n_entry = n_entry_ver5;
	}
	else
	{
		info -> reset_info();
		return;
	}


	// Make sure input format is this.
	//	(* * (view_mode % %)
	//	     (stamina % %)
	//	     (speed %)
	//	     (kick %)
	//	     (dash %)
	//	     (turn %)
	//	     (say %))
	for ( unsigned int  i = 0  ;  i < n_entry  ;  i ++ )
	{
		Lisp_Lexical_Object &	entry = input.list[i + 2];
		Sense_Body_Format	entry_format = format[i];

		// Make sure each input entry's format is this.
		//	     (* *) || (* * *)
		if ( entry.type  !=  Lisp_Lexical_Object::List
		 ||  entry.list.size() != entry_format.n_arguments + 1)
		{
			info -> reset_info();
			return;
		}

		// Make sure each input entry's format is this.
		//	     (% %) || (% % %)
		for ( unsigned int  x = 0  ;  x < entry_format.n_arguments  ;
		      x ++ )
		{
			if ( entry.list[x].type
			     !=  Lisp_Lexical_Object::Symbol )
			{
				info -> reset_info();
				return;
			}
		}

		// Make sure each input entry's format is this.
		//	(view_mode % %) || (stamina % %) || ...
		if ( entry.list[0].symbol != entry_format.parameter )
		{
			info -> reset_info();
			return;
		}
	}
	//
	// Test input format
	//
	// end


	// no errors.
	// now, we know input data format is valid.


	//
	// Set parameter to Body_Info_from_Server instance.
	//
	// start

	Body_Info_from_Server	body;

	string	vq = input.list[2].list[1].symbol;
	if ( vq == "high" )
	{
		body.v_quality = View_Quality::High;
	}
	else if ( vq == "low" )
	{
		body.v_quality = View_Quality::Low;
	}
	else
	{
		info -> reset_info();
		return;
	}


	string	va = input.list[2].list[2].symbol;
	if ( va == "wide" )
	{
		body.v_angle = View_Angle::Wide;
	}
	else if ( va == "normal" )
	{
		body.v_angle = View_Angle::Normal;
	}
	else if ( va == "narrow" )
	{
		body.v_angle = View_Angle::Narrow;
	}
	else
	{
		info -> reset_info();
		return;
	}

	if ( sense_body_version == 4 )
	{
		if ( ! str_to_real( &body.stamina ,
				    input.list[3].list[1].symbol )
		  || ! str_to_real( &body.effort  ,
				    input.list[3].list[2].symbol )
		  || ! str_to_real( &body.speed   ,
				    input.list[4].list[1].symbol )
		  || ! str_to_int ( &body.n_kick  ,
				    input.list[5].list[1].symbol )
		  || ! str_to_int ( &body.n_dash  ,
				    input.list[6].list[1].symbol )
		  || ! str_to_int ( &body.n_turn  ,
				    input.list[7].list[1].symbol )
		  || ! str_to_int ( &body.n_say   ,
				    input.list[8].list[1].symbol ) )
		{
			info -> reset_info();
			return;
		}

		body.head_angle  = 0.0;
		body.n_turn_neck = 0;
	}
	else // if ( sense_body_version == 5 )
	{
		if ( ! str_to_real( &body.stamina     ,
				    input.list[3].list[1].symbol )
		  || ! str_to_real( &body.effort      ,
				    input.list[3].list[2].symbol )
		  || ! str_to_real( &body.speed       ,
				    input.list[4].list[1].symbol )
		  || ! server_str_to_dir( &body.head_angle ,
					  input.list[5].list[1].symbol ,
					  use_radian )
		  || ! str_to_int ( &body.n_kick      ,
				    input.list[6].list[1].symbol )
		  || ! str_to_int ( &body.n_dash      ,
				    input.list[7].list[1].symbol )
		  || ! str_to_int ( &body.n_turn      ,
				    input.list[8].list[1].symbol )
		  || ! str_to_int ( &body.n_say       ,
				    input.list[9].list[1].symbol )
		  || ! str_to_int ( &body.n_turn_neck ,
				    input.list[10].list[1].symbol ) )
		{
			info -> reset_info();
			return;
		}
	}


	//
	// Set parameter to Body_Info_from_Server instance.
	//
	// end

	//
	// Rest is to set data that we get only.
	//
	info ->  set_info( body );
}


bool   SServer_Message_Translator::analyze_body_info_brief(
					      Information_from_Server * info ,
					      const string &  mes ,
					      bool  use_radian )
{
	//
	// Format
	//
	//	(sense_body % (view_mode % %)
	//	              (stamina % %)
	//	              (speed %)
	//	              (kick %)
	//	              (dash %)
	//	              (turn %)
	//	              (say %))
	// * : list or symbol
	// % : symbol

	int	info_time;

	Body_Info_from_Server	body;

	// XXX: magic number 256
	char	view_quality[256 + 1];
	char	view_angle[256 + 1];

	if ( sscanf( mes.c_str() ,
		     "(sense_body %d (view_mode %256s %256s"
		     " (stamina %lf %lf)"
		     " (speed %lf) (head_angle %lf)"
		     " (kick %d) (dash %d) (turn %d)"
		     " (say %d) (turn_neck %d))" ,
		     &info_time , view_quality , view_angle ,
		     &(body.stamina) , &(body.effort) ,
		     &(body.speed) , &(body.head_angle) ,
		     &(body.n_kick) , &(body.n_dash) , &(body.n_turn) ,
		     &(body.n_say) , &(body.n_turn_neck) ) == 12 )
	{
	}
	else if ( sscanf( mes.c_str() ,
			  "(sense_body %d (view_mode %256s %256s"
			  " (stamina %lf %lf)"
			  " (speed %lf)"
			  " (kick %d) (dash %d) (turn %d)"
			  " (say %d))" ,
			  &info_time , view_quality , view_angle ,
			  &(body.stamina) , &(body.effort) ,
			  &(body.speed) ,
			  &(body.n_kick) , &(body.n_dash) , &(body.n_turn) ,
			  &(body.n_say) ) == 10 )
	{
		body.head_angle = 0.0;
		body.n_turn_neck = 0;
	}
	else
	{
		return( false );
	}


	info -> set_time( info_time );


	if ( strcmp( view_quality , "high" ) == 0 )
	{
		body.v_quality = View_Quality::High;
	}
	else if ( strcmp( view_quality , "low" ) )
	{
		body.v_quality = View_Quality::Low;
	}
	else
	{
		return( false );
	}

	if ( strcmp( view_angle , "wide)" ) == 0 )
	{
		body.v_angle = View_Angle::Wide;
	}
	else if ( strcmp( view_angle , "normal)" ) == 0 )
	{
		body.v_angle = View_Angle::Normal;
	}
	else if ( strcmp( view_angle , "narrow)" ) == 0 )
	{
		body.v_angle = View_Angle::Narrow;
	}
	else
	{
		return( false );
	}

	server_real_to_dir( &(body.head_angle) , body.head_angle ,
			    use_radian );

	info ->  set_info( body );

	return( true );
}


void   SServer_Message_Translator::analyze_error_info(
					      Information_from_Server *  info ,
					      Lisp_Lexical_Object &  input )
{
	if ( input.list.size() != 2
	  || input.list[1].type != Lisp_Lexical_Object::Symbol )
	{
		info -> reset_info();
		return;
	}

	Error_Info_from_Server	err;
	err.error_message = input.list[1].symbol;

	info ->  set_info( err );
}


void   SServer_Message_Translator::analyze_debug_info(
					      Information_from_Server *  info ,
					      Lisp_Lexical_Object &  input )
{
	if ( ! (input.list.size() > 2) )
	{
		info -> reset_info();
		return;
	}

	Debug_Info_from_Server	debug;

	for ( size_t  i = 2  ;  i < input.list.size()  ;  i ++ )
	{
		if ( input.list[i].type != Lisp_Lexical_Object::List
		  || input.list[i].list.size() == 0 )
		{
			     info -> reset_info();
			     return;
		}

		if ( input.list[i].list[0].symbol == "my_coordinate"
		  && (input.list[i].list.size() == 3
		      || input.list[i].list.size() == 4
		      || input.list[i].list.size() == 5 ) )
		{
			double	cood_x;
			double	cood_y;

			if ( ! str_to_real( &cood_x ,
					    input.list[i].list[1].symbol )
			  || ! str_to_real( &cood_y ,
					    input.list[i].list[2].symbol ) )
			{
			     info -> reset_info();
			     return;
			}

			debug.true_my_coordinate.set( cood_x , cood_y );
			debug.have_true_my_coordinate = true;

			if ( input.list[i].list.size() >= 4 )
			{
				if ( ! server_str_to_dir(
						&(debug.true_my_body_angle) ,
						input.list[i].list[3].symbol ,
						true ) )
				{
					info -> reset_info();
					return;
				}

				debug.have_true_my_body_angle = true;
			}

			if ( input.list[i].list.size() >= 5 )
			{
				if ( ! server_str_to_dir(
						&(debug.true_my_face_angle) ,
						input.list[i].list[4].symbol ,
						true ) )
				{
					info -> reset_info();
					return;
				}

				debug.have_true_my_face_angle = true;
			}
		}
		else if ( input.list[i].list[0].symbol == "my_angle"
		       && input.list[i].list.size() == 2 )
		{
			if ( ! server_str_to_dir(
					&(debug.true_my_body_angle) ,
					input.list[i].list[0].symbol , true ) )
			{
			     info -> reset_info();
			     return;
			}

			debug.have_true_my_body_angle = true;
		}
		else
		{
			info -> reset_info();
			return;
		}
	}

	info ->  set_info( debug );
}



bool   SServer_Message_Translator::str_to_real( double *  num ,
						const string &  str )
{
	if ( str.find( " "  ) != string::npos
	  || str.find( "\t" ) != string::npos
	  || str.find( "\n" ) != string::npos )
	{
		return( false );
	}

	char *	c;
	double	double_num;
	double_num = strtod( str.c_str() , &c );

	if ( *c != '\0'
	 ||  double_num == HUGE_VAL )
	{
		return( false );
	}
	else
	{
		*num = double_num;

		return( true );
	}
}

bool   SServer_Message_Translator::str_to_int( int *  num ,
					       const string &  str )
{
	if ( str.find( " "  ) != string::npos
	  || str.find( "\t" ) != string::npos
	  || str.find( "\n" ) != string::npos )
	{
		return( false );
	}

	char *	c;
	long	long_num;
	long_num = strtol( str.c_str() , &c , 10 );

	if ( *c != '\0'
	 ||  (long_num == LONG_MIN || long_num == LONG_MAX)
	 ||  (long_num < INT_MIN || INT_MAX < long_num) )
	{
		return( false );
	}
	else
	{
		*num = static_cast<int>(long_num);

		return( true );
	}
}


bool   SServer_Message_Translator::server_str_to_dir( double *  dir ,
						      const string &  str ,
						      bool use_radian )
{
	if ( ! str_to_real( dir , str ) )
	{
		return( false );
	}

	server_real_to_dir( dir , *dir , use_radian );

	return( true );
}

void   SServer_Message_Translator::server_real_to_dir( double *  dir ,
						       double  real ,
						       bool  use_radian )
{
	if ( use_radian )
	{
		(*dir) = dig_to_rad( real );
	}
}

void   SServer_Message_Translator::user_input_to_y( double *  new_y ,
						    double  y )
{
	(*new_y) = y;
}

void   SServer_Message_Translator::user_input_to_dir( double *  new_dir ,
						      double  dir ,
						      bool  use_radian )
{
	if ( use_radian )
	{
		(*new_dir) = rad_to_dig( dir );
	}
	else
	{
		(*new_dir) = dir;
	}
}


double  SServer_Message_Translator::dig_to_rad( double  dig )
{
	return( dig * (M_PI / 180.0) );
}

double  SServer_Message_Translator::rad_to_dig( double  rad )
{
	return( rad * (180.0 / M_PI) );
}


S_Side  SServer_Message_Translator::lr_to_side( char  l_or_r ,
						S_Side_LR  our_side )
{
	return( lr_to_side( string( 1 , l_or_r ) , our_side ) );
}


S_Side  SServer_Message_Translator::lr_to_side( const string &  l_or_r ,
						S_Side_LR  our_side )
{
	if ( l_or_r == "l"  &&  our_side == S_Side_LR::Left_Side
	  || l_or_r == "r"  &&  our_side == S_Side_LR::Right_Side )
	{
		return( S_Side::Our_Side );
	}
	else if ( l_or_r == "l"  &&  our_side == S_Side_LR::Right_Side
	       || l_or_r == "r"  &&  our_side == S_Side_LR::Left_Side )
	{
		return( S_Side::Opponent_Side );
	}
	else
	{
		return( S_Side::Unknown );
	}
}
