#include <libCMU.h>
#include <zeng.h>

#include <string.h>

Bool their_corner_kick(void)
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() < 0.6 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;		
	}
	else
	{
		if ( Mem->ClosestTeammateToBall() == Mem->MyNumber
		     || ( Mem->ClosestTeammateToBall() == 1 && how_many_closer_teammate(Mem->BallAbsolutePosition()) < 2 ) )
		{
			if ( Mem->BallDistance() > buffer )
			{
				if ( my_go_to_position ( Mem->BallAbsolutePosition() , Vector( -40 , 0.0 ) , buffer + 3 , 40 , 2.0)==TRUE) return TRUE ;
				return FALSE ;
			}
			else
			{
				if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
		}
		else if ( fabs( Mem->BallAbsolutePosition().x - MyProp->their_cornerkick.x ) < 10 )
		{
			if ( Mem->BallDistance() > buffer )
			{
				if ( go_to_point ( Vector (MyProp->their_cornerkick.x,MyProp->pos2.y) , 2.0 , 35 ) == AQ_ActionNotQueued )
				{
					if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return ( TRUE ) ;
			}
			else
			{
				if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
		}
		else
		{
			if ( Mem->BallDistance() > buffer )
			{
				if ( go_to_point ( MyProp ->their_cornerkick , 2.0 , 40 ) == AQ_ActionNotQueued )
				{
					if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return ( TRUE ) ;
			}
			else
			{
				if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
		}
	}
	return FALSE ;
}

Bool my_corner_kick(void)
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallKickable() )
	{
		int i = 0 ;
		for ( Unum u = 5 ; u <= 11 ; ++ u )
		{
			if ( Mem->TeammatePositionValid(u) > 0.8 )
			{
				i ++ ;
			}
		}

		if ( i > 4 )
		{
			if ( scan_field() ==  AQ_ActionNotQueued ) return FALSE ;
			return TRUE ;
		}
		else
		{
			for ( Unum u = 5 ; u <= 11 ; ++ u )
			{
				if ( pass_centering ( u ) == TRUE ) return TRUE ;
			}

			if ( MF_pass_center() == TRUE ) return TRUE ;
			if ( center_pass ( MyProp->my_cornerkick_point ) == TRUE ) return TRUE ;

			//temporary
			if ( Mem->BallAbsolutePosition().y > 0 )
			{
				//
				kick_to_xy(Vector(Mem->BallAbsolutePosition().x-1.0,
						  Mem->BallAbsolutePosition().y-1.0) ) ;
			}
			else
			{
				//
				kick_to_xy(Vector(Mem->BallAbsolutePosition().x-1.0,
						  Mem->BallAbsolutePosition().y+1.0) ) ;
			}
			return TRUE ;
		}
	}
	else
	{
		if ( Mem->BallPositionValid() )
		{
			//tmp
			if ( Mem->ClosestTeammateToBall() == Mem->MyNumber
			     || ( ( ( Mem->ClosestTeammateToBall() == 10
				      || Mem->ClosestTeammateToBall() == 11 ) )
				  && how_many_closer_teammate(Mem->BallAbsolutePosition()) < 2 ) )
			{
				if ( go_to_point ( Mem->BallAbsolutePosition() , Mem->SP_ball_size + 0.5 , 20 ) == AQ_ActionNotQueued )
				{
					if ( scan_field() ==  AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
			else
			{
				if ( go_to_point(MyProp->my_cornerkick ,buffer,50) == AQ_ActionNotQueued )
				{
					if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
		}
		else
		{
			if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
			return TRUE ;
		}
	}
	return FALSE ;
}

Bool their_goal_kick(void)
{
	double buffer = minimal_buffer() ;

	Rectangle keep_out_area
		= Rectangle ( Mem->SP_pitch_length/2 - Mem->SP_penalty_area_length - 1.0 , //left
			      Mem->SP_pitch_length/2 + 1.0 ,                          //right
			     -Mem->SP_penalty_area_width/2 - 1.0 ,                    //top
			     Mem->SP_penalty_area_width/2  + 1.0 ) ;                  //bottom

	if ( Mem->BallPositionValid() < 0.7 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}

	if ( Mem->BallInTheirPenaltyArea() )
	{
		if ( keep_out_area.IsWithin(Mem->MyPos()) == TRUE )
		{
			if ( scan_field() ==  AQ_ActionNotQueued ) return FALSE ;
			return TRUE ;
		}
		else
		{

			if ( go_to_point(MyProp->their_goalkick ,buffer,50) == AQ_ActionNotQueued )
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
	}
	else
	{
#if 1
		double x = Mem->my_offside_line - MyProp->offside_line_offset ;
		if ( x <= MyProp->x_upper_limit )
			x = MyProp->x_upper_limit ;
#endif
		if ( go_to_point ( Vector(x,MyProp->their_goalkick.y) , buffer , 35 ) == AQ_ActionNotQueued)
		{
			if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
			return TRUE ;
		}
		return TRUE ;
	}
	return FALSE ;
}

Bool their_free_kick ( void )
{
	double buffer = minimal_buffer() ;

	Rectangle keep_out_area
		= Rectangle ( Mem->SP_pitch_length/2 - Mem->SP_penalty_area_length - 1.0 , //left
			      Mem->SP_pitch_length/2 + 1.0 ,                           //right
			     -Mem->SP_penalty_area_width/2 - 1.0 ,                     //top
			     Mem->SP_penalty_area_width/2  + 1.0 ) ;                     //bottom

	if ( Mem->BallPositionValid() < 0.7 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}

	if ( Mem->BallInTheirPenaltyArea() )
	{
		if ( keep_out_area.IsWithin(Mem->MyPos()) == TRUE )
		{
			if ( scan_field() ==  AQ_ActionNotQueued ) return FALSE ;
			return TRUE ;
		}
		else
		{
			if ( go_to_point(MyProp->their_freekick ,buffer,40) == AQ_ActionNotQueued )
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
	}
	else
	{
		if ( Mem->TeammateInOffsidePosition(Mem->MyNumber ) )
		{
			if ( go_to_point (Vector (Mem->their_offside_line - MyProp->offside_line_offset , MyProp->their_freekick.y)
					  , buffer , 40 ) == AQ_ActionNotQueued )
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
		else
		{
			if ( go_to_point ( MyProp->their_freekick , buffer , 30 ) == AQ_ActionNotQueued)
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
	}
	return FALSE ;
}

Bool their_offside_kick ( void )
{
	double buffer = minimal_buffer() ;

	Rectangle keep_out_area
		= Rectangle ( Mem->SP_pitch_length/2 - Mem->SP_penalty_area_length - 1.0 , //left
			      Mem->SP_pitch_length/2 + 1.0 ,                           //right
			     -Mem->SP_penalty_area_width/2 - 1.0 ,                     //top
			     Mem->SP_penalty_area_width/2  + 1.0 ) ;                     //bottom

	if ( Mem->BallPositionValid() < 0.7 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}

	if ( Mem->BallInTheirPenaltyArea() )
	{
		if ( keep_out_area.IsWithin(Mem->MyPos()) == TRUE )
		{
			if ( scan_field() ==  AQ_ActionNotQueued ) return FALSE ;
			return TRUE ;
		}
		else
		{
			if ( go_to_point(MyProp->their_offsidekick ,buffer,40) == AQ_ActionNotQueued )
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
	}
	else
	{
		if ( Mem->TeammateInOffsidePosition(Mem->MyNumber ) )
		{
			if ( go_to_point (Vector (Mem->my_offside_line - MyProp->offside_line_offset , MyProp->my_offsidekick.y)
					  , buffer , 40 ) == AQ_ActionNotQueued )
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
		else
		{
			if ( go_to_point ( MyProp->their_offsidekick , buffer , 30 ) == AQ_ActionNotQueued)
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
	}
	return FALSE ;
}

Bool their_kick_off ( void )
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() < 0.7 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}
	else
	{
		//go to position

		if ( scan_field() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}

	return FALSE ;
}

Bool my_goal_kick ( void )
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() < 0.6 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}
	else
	{
		//go to position
		if ( Mem->TeammateInOffsidePosition(Mem->MyNumber ) )
		{
			if ( go_to_point (Vector (Mem->my_offside_line - MyProp->offside_line_offset , MyProp->my_goalkick.y)
					  , buffer , 50 ) == AQ_ActionNotQueued )
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
		else
		{
			if ( go_to_point ( MyProp->my_goalkick , buffer , 50 ) == AQ_ActionNotQueued)
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
	}

	return FALSE ;

}

Bool my_free_kick ( void )
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() < 0.6 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}

	if ( Mem-> BallInOwnPenaltyArea() )
	{
		if ( Mem->TeammateInOffsidePosition(Mem->MyNumber ) )
		{
			if ( go_to_point (Vector (Mem->my_offside_line - MyProp->offside_line_offset , MyProp->my_freekick.y)
					  , buffer , 50 ) == AQ_ActionNotQueued )
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
		else
		{
			if ( go_to_point ( MyProp->my_freekick , buffer , 50 ) == AQ_ActionNotQueued)
			{
				if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
			return TRUE ;
		}
	}
	else
	{
		if ( Mem->ClosestTeammateToBall() == Mem->MyNumber
		     || ( Mem->ClosestTeammateToBall() == 1 && how_many_closer_teammate(Mem->BallAbsolutePosition())  < 2 ) )
		{
			if (Mem->BallKickable())
			{
				if ( shoot_near_post(25) == TRUE ) return TRUE ;
				if ( MF_pass_forward() == TRUE ) return TRUE ;
				for ( Unum u = 5 ; u <= 11 ; ++ u )
				{
					if ( through_pass(u) == TRUE ) return TRUE ;
				}
				if ( forward_pass ( MyProp->my_freekick_point ) == TRUE ) return TRUE ;
				if ( fabs(Mem->BallY()) > 16 )
				{
					if ( MF_pass_center() == TRUE ) return TRUE ;
					if ( MF_pass_side() == TRUE ) return TRUE ;
				}
				else
				{
					if ( MF_pass_side() == TRUE ) return TRUE ;
					if ( MF_pass_center() == TRUE ) return TRUE ;
				}
				if ( shoot_near_post(30) == TRUE ) return TRUE ;
				//temporary
				if ( Mem->BallAbsolutePosition().y > 0 )
				{
					kick_ball (Vector( Mem->BallX() + 30 , fabs(MyProp->my_freekick_point.y) ) ,KM_HardestKick ) ;
				}
				else
				{
					kick_ball (Vector( Mem->BallX() + 30 , -fabs(MyProp->my_freekick_point.y) ) ,KM_HardestKick ) ;
				}

				return TRUE ;
			}
			else
			{
				if ( go_to_point ( Mem->BallAbsolutePosition() , buffer , 30 ) == AQ_ActionNotQueued )
				{
					if ( scan_field() == AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
		}
		else
		{
			if ( Mem->TeammateInOffsidePosition(Mem->MyNumber ) )
			{
				if ( go_to_point (Vector (Mem->my_offside_line - MyProp->offside_line_offset , MyProp->my_freekick.y)
						  , buffer , 50 ) == AQ_ActionNotQueued )
				{
					if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
			else
			{
				if ( go_to_point ( MyProp->my_freekick , buffer , 50 ) == AQ_ActionNotQueued)
				{
					if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
		}
	}
	return FALSE ;
}

Bool my_offside_kick ( void )
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() < 0.6 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}

	if ( Mem-> BallInOwnPenaltyArea() )
	{
		if ( go_to_point ( MyProp->my_offsidekick , buffer , 50 ) == AQ_ActionNotQueued)
		{
			if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
			return TRUE ;
		}
		return TRUE ;
	}
	else
	{
		if ( Mem->ClosestTeammateToBall() == Mem->MyNumber
		     || ( Mem->ClosestTeammateToBall() == 1 && how_many_closer_teammate(Mem->BallAbsolutePosition()) < 2 ) )
		{
			if (Mem->BallKickable())
			{
				//if ( shoot_near_post(25) == TRUE ) return TRUE ;
				if ( MF_pass_forward() == TRUE ) return TRUE ;
				for ( Unum u = 5 ; u <= 11 ; ++ u )
				{
					if ( through_pass(u) == TRUE ) return TRUE ;
				}
				if ( forward_pass ( MyProp->my_offsidekick_point ) == TRUE ) return TRUE ;
				if ( fabs(Mem->BallY()) > 16 )
				{
					if ( MF_pass_center() == TRUE ) return TRUE ;
					if ( MF_pass_side() == TRUE ) return TRUE ;
				}
				else
				{
					if ( MF_pass_side() == TRUE ) return TRUE ;
					if ( MF_pass_center() == TRUE ) return TRUE ;
				}
				if ( shoot_near_post(30) == TRUE ) return TRUE ;
				//temporary
				if ( Mem->BallAbsolutePosition().y > 0 )
				{
					kick_ball (Vector( Mem->BallX() + 30 , fabs(MyProp->my_offsidekick_point.y) ) ,KM_HardestKick ) ;
				}
				else
				{
					kick_ball (Vector( Mem->BallX() + 30 , -fabs(MyProp->my_offsidekick_point.y) ) ,KM_HardestKick ) ;
				}

				return TRUE ;
			}
			else
			{
				if ( go_to_point ( Mem->BallAbsolutePosition() , buffer , 30 ) == AQ_ActionNotQueued )
				{
					if ( scan_field() == AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
		}
		else
		{
			if ( Mem->TeammateInOffsidePosition(Mem->MyNumber ) )
			{
				if ( go_to_point (Vector (Mem->my_offside_line - MyProp->offside_line_offset , MyProp->my_offsidekick.y)
						  , buffer , 50 ) == AQ_ActionNotQueued )
				{
					if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
			else
			{
				if ( go_to_point ( MyProp->my_offsidekick , buffer , 50 ) == AQ_ActionNotQueued)
				{
					if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
		}
	}
	return FALSE ;
}

Bool my_kick_off ( void )
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() < 0.7 )
	{
		if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}
	else
	{
		if ( scan_field() ==  AQ_ActionNotQueued ) return FALSE ;
		return TRUE ;
	}
	return FALSE ;
}

Bool mode_action ( void )
{
	double buffer = minimal_buffer() ;

	switch ( Mem->PlayMode )
	{
		case PM_Play_On:
			return FALSE ;
		case PM_Before_Kick_Off:
			if ( before_kick_off() == TRUE ) return TRUE ;
		case PM_Their_Kick_Off:
			if ( their_kick_off() == TRUE ) return TRUE ;
		case PM_My_Kick_Off:
			if ( my_kick_off() == TRUE ) return TRUE ;

		case PM_Their_Goal_Kick:
			if ( their_goal_kick() == TRUE ) return TRUE ;
		case PM_My_Goal_Kick:
			if ( my_goal_kick() == TRUE ) return TRUE ;

		case PM_Their_Corner_Kick:
			if ( their_corner_kick() == TRUE ) return TRUE ;
		case PM_My_Corner_Kick:
			if ( my_corner_kick() == TRUE ) return TRUE ;

		case PM_Their_Kick_In:
			if ( their_kick_in() == TRUE ) return TRUE ;
		case PM_My_Kick_In:
			if ( my_kick_in() == TRUE ) return TRUE ;

		case PM_Their_Offside_Kick:
			if ( their_offside_kick() == TRUE ) return TRUE ;
		case PM_My_Offside_Kick:
			if ( my_offside_kick() == TRUE ) return TRUE ;

		case PM_Their_Free_Kick:
			if ( their_free_kick() == TRUE ) return TRUE ;
		case PM_My_Free_Kick:
			if ( my_free_kick() == TRUE ) return TRUE ;

		default:
			dance_counter = 0 ;
			say_counter = 0 ;
			move_counter = 0 ;
			//if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
			//return TRUE ;
			;
	}
	return FALSE ;
}

//Kubo + Morishita
Bool chase_ball(double buffer)
{
	Vector v ;

	if ( !Mem->BallMoving() )
	{
		if ( Mem->PlayerWithBall() < 0 )
		{
			v = Vector ( Mem->BallAbsolutePosition().x - 3 , Mem->BallAbsolutePosition().y ) ;
		}
		else if ( Mem->PlayerWithBall() > 0 && Mem->PlayerWithBall() != Mem->MyNumber )
		{
			v = Vector ( Mem->BallAbsolutePosition().x - 1 , MyProp->pos.y ) ;
		}
		else
		{
			v = Mem->BallAbsolutePosition() ;
		}
	}
	else
	{
		if ( Mem->ClosestTeammateToBall() == Mem->MyNumber )
		{
			change_stamina_limit( - 500 ) ;
		}

		if ( !Mem->MyInterceptionAble() )
		{
			if ( Mem->ClosestTeammateToBall() == Mem->MyNumber )
			{
				v = Mem->BallAbsolutePosition() ;
			}
			else
			{
				face_ball();
				return TRUE ;
			}
		}
		else
		{
			v = Mem->MyInterceptionPoint() ;
		}
	}

	if ( fabs ( Mem->MyY() - MyProp->pos.y ) > 20
	    &&
	    fabs ( v.y - MyProp->pos.y ) > 20 )
	{
		v.y = Mem->MyY();

		if ( go_to_point ( v, buffer , 30 ) == AQ_ActionNotQueued )
		{
			face_ball();
			TRUE ;
		}
	}
	else
	{
		if ( go_to_point(v, buffer, 100) == AQ_ActionNotQueued )
		{
			face_ball();
			return TRUE ;
		}
	}
	return FALSE ;
}

Bool shoot_near_post ( int dist )
{
	double shoot_dist ;
	if ( Mem -> DistanceTo ( Vector ( 52.5 , Mem -> SP_goal_width / 2.0 ) )
	     <
	     Mem -> DistanceTo ( Vector ( 52.5 , - Mem -> SP_goal_width / 2.0 ) ) )
	{
		shoot_dist = Mem -> DistanceTo ( Vector ( 52.5 , Mem -> SP_goal_width / 2.0 ) ) ;
		if ( shoot_dist < dist )
		{
			kick_ball (Vector ( 52.5 , Mem -> SP_goal_width / 2.0 - 1.0 ) , KM_HardestKick ,TURN_AVOID) ;
			return TRUE ;
		}
	}
	else
	{
		shoot_dist = Mem -> DistanceTo ( Vector ( 52.5 , - Mem -> SP_goal_width / 2.0 ) ) ;
		if ( shoot_dist < dist )
		{
			kick_ball (Vector ( 52.5 , -Mem -> SP_goal_width / 2.0 + 1.0 ) , KM_HardestKick ,TURN_AVOID) ;
			return TRUE ;
		}
	}

	return FALSE ;
}

Bool shoot_near_post ( void )
{
	return ( shoot_near_post ( 25 ) ) ;
}

Bool DF_Pos1()
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() )
	{
		Vector v ;
		Vector v1 ;
		Vector v2 ;

		//R
		if ( Mem->BallY() > 0 )
		{
 			if ( Mem->CP_role != 4 ) return FALSE;
			v1 = Mem->MarkerPosition(Mem->RM_My_Goal) + Vector ( 0 , Mem->SP_goal_width / 2.0 ) ;
			v2 = Mem->BallAbsolutePosition() ;
		}
		//L
		else
		{
 			if ( Mem->CP_role != 3 ) return FALSE;
			v1 = Mem->MarkerPosition(Mem->RM_My_Goal) - Vector ( 0 , Mem->SP_goal_width / 2.0 ) ;
			v2 = Mem->BallAbsolutePosition() ;

		}

		v = v2 - v1 ;

		if ( v.mod() >= 5.0  )
		{
			v = v1 + v * ( v.mod() - 5 ) / v.mod() ;

			float v_dist = Mem->DistanceTo(v) ;

			if ( Mem->BallX() > -15 )
			{
				if ( go_to_point ( v , buffer , 40 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
			}
			else
			{
				if ( go_to_point ( v , buffer , 100 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
			}
			return TRUE;
		}
		else
		{
			if ( !Mem->MyInterceptionAble() )
			{
				return FALSE ;
			}
			else
			{
				v = Mem->MyInterceptionPoint() ;
				if ( go_to_point ( v , buffer , 100 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
				return TRUE ;
			}

		}
	}
}

Bool DF_Pos2()
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() )
	{
		Vector v ;
		Vector v1 ;
		Vector v2 ;

		//R
		if ( Mem->BallY() > 0 )
		{
 			if ( Mem->CP_role != 3 ) return FALSE;

			if ( Mem->BallX() > -32 )
				v1 = Vector ( - 32.0 , -14.0 ) ;
			else
				v1 = Vector ( - 40.0 , -14.0 ) ;
			v2 = Mem->BallAbsolutePosition() ;
		}
		//L
		else
		{
 			if ( Mem->CP_role != 4 ) return FALSE;

			if ( Mem->BallX() > -32 )
				v1 = Vector ( - 32.0 , 14.0 ) ;
			else
				v1 = Vector ( - 40.0 , 14.0 ) ;
			v2 = Mem->BallAbsolutePosition() ;

		}

		v = v1 - v2 ;

		if ( v.mod() >= 8.0  )
		{
			v = v2 + v * ( v.mod() - 8.0 ) / v.mod() ;

			float v_dist = Mem->DistanceTo(v) ;

			if ( Mem->BallX() > -15 )
			{
				if ( go_to_point ( v , buffer , 40 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
			}
			else
			{
				if ( go_to_point ( v , buffer , 100 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
			}
			return TRUE;
		}
		else if ( v.mod() < 3.0 )
		{
			if ( !Mem->MyInterceptionAble() )
			{
				return FALSE ;
			}
			else
			{
				v = Mem->MyInterceptionPoint() ;
				if ( go_to_point ( v , buffer , 100 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
				return TRUE ;
			}
		}
		else
		{
			return FALSE ;
		}
	}
}

Bool DF_Pos3()
{
	double buffer = minimal_buffer() ;

	if ( Mem->CP_role != 2 ) return FALSE;
	if ( Mem->BallPositionValid() )
	{
		Vector v ;
		Vector v1 ;
		Vector v2 ;

		if ( Mem->BallX() > -34 )
			v1 = Vector ( -34.0 , 0.0 ) ;
		else
			v1 = Vector ( -40.0 , 0.0 ) ;

		v2 = Mem->BallAbsolutePosition() ;

		v = v1 - v2 ;

		if ( v.mod() >= 8.0  )
		{
			v = v2 + v * ( v.mod() - 8.0 ) / v.mod() ;

			float v_dist = Mem->DistanceTo(v) ;

			if ( Mem->BallX() > -15 )
			{
				if ( go_to_point ( v , buffer , 40 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
			}
			else
			{
				if ( go_to_point ( v , buffer , 100 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
			}
			return TRUE;
		}
		else if ( v.mod() < 3.0 )
		{
			if ( !Mem->MyInterceptionAble() )
			{
				return FALSE ;
			}
			else
			{
				v = Mem->MyInterceptionPoint() ;
				if ( go_to_point ( v , buffer , 100 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
				return TRUE ;
			}

			return ( FALSE ) ;
		}
		else
		{
			return ( FALSE ) ;
		}
	}
}

Bool my_go_to_position ( Vector v1 , Vector v2 , double dist , double vel ,double buffer )
{
	if ( Mem->BallPositionValid() )
	{
		Vector v ;
		v = v1 - v2 ;

		if ( v.mod() >= dist  )
		{
			v = v2 + v * ( v.mod() - dist ) / v.mod() ;

			float v_dist = Mem->DistanceTo(v) ;

			if ( go_to_point ( v , buffer , vel ) == AQ_ActionNotQueued )
			{
				face_ball() ;
			}
			return ( TRUE ) ;
		}
		else
		{
			return ( FALSE ) ;
		}
	}
}

Bool pass_check1(Unum unum)
{

#ifdef CMU99
  double pass_angle = Mem->TeammateAngleFromBody(unum) ;
#else
  double pass_angle = Mem->TeammateAngle(unum) ;
#endif
  double diff_min = 180;
  double pass_dist = Mem->TeammateDistance(unum) ;

  double op_dist  ;
  double op_dir ;

  for (Unum e = 1; e <= 11; e++)
    {
      if (Mem->OpponentPositionValid(e) > 0.75 )
	{
		if ( pass_dist <= Mem->OpponentDistance(e) )
		{
#ifdef CMU99
			double diff_angle = fabs(Mem->OpponentAngleFromBody(e) - pass_angle);
#else
			double diff_angle = fabs(Mem->OpponentAngle(e) - pass_angle);
#endif
			diff_min = diff_min < diff_angle ? diff_min : diff_angle ;
		}
	}
    }

  if ( pass_dist <= 10 )
	  return diff_min > 5 ? TRUE : FALSE;
  else
	  return diff_min > 10 ? TRUE : FALSE;
}

Bool pass_check2(Unum unum)
{
	for (Unum e = 1; e <= 11; e++)
	{
		if ( Mem->OpponentPositionValid(e) > 0.7 )
		{
			if ( Mem->TeammateDistanceTo(unum,Mem->OpponentAbsolutePosition(e)) <= 5 )
			{
				return ( FALSE ) ;
			}
		}
	}
	return ( TRUE ) ;
}

Bool pass_check3(Unum unum)
{
	double pass_dist = Mem->TeammateDistance(unum) ;

	KickMode mode ;
#ifdef CMU99
	mode = Mem->BestKickMode(Mem->TeammateAngleFromBody(unum) ) ;
#else
	mode = Mem->BestKickMode(Mem->TeammateAngle(unum) ) ;
#endif		
	switch ( mode )
	{
		case KM_None:
		case KM_Hard:
			return FALSE ;
			break ;
		case KM_HardestKick:
			if ( pass_dist > 30.0 )
				return FALSE ;
			else
				return TRUE ;
			break ;
		case KM_Moderate:
			if ( pass_dist > 20.0 )
				return FALSE ;
			else
				return TRUE ;
			break ;
		case KM_Quickly:
			if ( pass_dist > 15.0 )
				return FALSE ;
			else
				return TRUE ;
			break ;
		case KM_QuickestRelease:
			if ( pass_dist > 15.0 )
				return FALSE ;
			else
				return TRUE ;

			break ;
		default:
			return FALSE ;
	}
}

Bool pass_check(Unum unum)
{
	if ( pass_check1(unum) && pass_check2(unum) && pass_check3(unum) )
		return ( TRUE ) ;
	else
		return ( FALSE ) ;
}

Bool MF_pass_forward()
{
	//unum = pass_select() ;

	for (int i = 11; i > 1 ; i-- )
	{
		if (Mem->TeammatePositionValid(i) && pass_check(i) )
		{
			if ( (!Mem->TeammateInOffsidePosition(i))
			     && ( Mem->TeammateAbsolutePosition(i).x >= Mem->TeammateAbsolutePosition(Mem->MyNumber).x )
			     && ( Mem->TeammateDistance(i) > 5.0 ) )

			{

				if ( i == Mem->MyNumber )
					continue ;

#ifdef CMU99
				//kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngleFromBody(i)),TURN_AVOID) ;
				pass_ball(i) ;
#else
				//kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)),TURN_AVOID) ;
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)) ) ;
#endif
				return ( TRUE ) ;
			}
		}
	}

	return FALSE ;
}

Bool MF_pass_center()
{
	for (int i = 11; i > 1 ; i--)
	{
		if (Mem->TeammatePositionValid(i) > 0.8 && pass_check(i))
		{
			if ( (!Mem->TeammateInOffsidePosition(i))
			     && ( fabs(Mem->TeammateAbsolutePosition(i).x - Mem->TeammateAbsolutePosition(Mem->MyNumber).x) < 5 )
			     && ( fabs ( Mem->TeammateAbsolutePosition(i).y) < fabs(Mem->TeammateAbsolutePosition(Mem->MyNumber).y) )
			     && ( Mem->TeammateDistance(i) > 5.0 ) )
			{
				if ( i == Mem->MyNumber )
					continue ;

#ifdef CMU99
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngleFromBody(i)),TURN_AVOID ) ;
#else
				//kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)),TURN_AVOID ) ;
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)) ) ;
#endif
				return ( TRUE ) ;
			}
		}
	}
	return FALSE ;
}

Bool MF_pass_side()
{
	for (int i = 11; i > 1 ; i--)
	{
		if (Mem->TeammatePositionValid(i) > 0.8 && pass_check(i))
		{
			if ( (!Mem->TeammateInOffsidePosition(i))
			     && ( fabs(Mem->TeammateAbsolutePosition(i).x - Mem->TeammateAbsolutePosition(Mem->MyNumber).x) < 5 )
			     && ( fabs ( Mem->TeammateAbsolutePosition(i).y) > fabs(Mem->TeammateAbsolutePosition(Mem->MyNumber).y) )
			     && ( Mem->TeammateDistance(i) > 5.0 ) )
			{

#ifdef CMU99
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngleFromBody(i)),TURN_AVOID) ;
#else
				//kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)),TURN_AVOID) ;
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)) ) ;
#endif
				return ( TRUE ) ;
			}
		}
	}
	return FALSE ;
}

Bool DF_pass_forward()
{
	//unum = pass_select() ;

	for (int i = 8; i > 4 ; i-- )
	{
		if (Mem->TeammatePositionValid(i) > 0.8 && pass_check(i) &&
		    Mem->TeammateAbsolutePosition(i).x > -25 && Mem->TeammateDistance(i) < 25 )
		{
			if ( (!Mem->TeammateInOffsidePosition(i))
			     && ( Mem->TeammateAbsolutePosition(i).x >= Mem->TeammateAbsolutePosition(Mem->MyNumber).x ) )
			{
				if ( i == Mem->MyNumber )
					continue ;

#ifdef CMU99
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngleFromBody(i)),TURN_AVOID) ;
#else
				//kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)),TURN_AVOID) ;
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i))) ;
#endif
				return ( TRUE ) ;
			}
		}
	}

	for (int i = 11; i > 8 ; i-- )
	{
		if (Mem->TeammatePositionValid(i) > 0.8 && pass_check(i)
		    && Mem->TeammateAbsolutePosition(i).x > -25 && Mem->TeammateDistance(i) < 25 )
		{
			if ( (!Mem->TeammateInOffsidePosition(i))
			     && ( Mem->TeammateAbsolutePosition(i).x >= Mem->TeammateAbsolutePosition(Mem->MyNumber).x ) )
			{
				if ( i == Mem->MyNumber )
					continue ;

#ifdef CMU99
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngleFromBody(i)),TURN_AVOID) ;
#else
				//kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)),TURN_AVOID) ;
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i))) ;
#endif
				return ( TRUE ) ;
			}
		}
	}

	return FALSE ;
}

Bool pass_centering ( Unum u )
{
	if ( Mem->TeammatePositionValid(u) > 0.7 )
	{
		Vector pass_pos = Mem->TeammateAbsolutePosition(u) ;

		//tmp
		pass_pos += Vector ( 5.0 , 5.0 ) ;
		if ( center_pass ( pass_pos ) == TRUE ) return TRUE ;
		pass_pos += Vector ( 5.0 , 0.0 ) ;
		if ( center_pass ( pass_pos ) == TRUE ) return TRUE ;
		pass_pos += Vector ( 5.0 , -5.0 ) ;
		if ( center_pass ( pass_pos ) == TRUE ) return TRUE ;

		return TRUE ;
	}
	return FALSE ;
}

Bool through_pass(Unum u)
{
	//unum = pass_select() ;

	if ( Mem->TeammatePositionValid(u) > 0.7 )
	{
		Vector pass_pos = Mem->TeammateAbsolutePosition(u) ;

		//tmp
		pass_pos += Vector ( 10.0 , 5.0 ) ;
		if ( forward_pass ( pass_pos ) == TRUE ) return TRUE ;
		pass_pos += Vector ( 10.0 , 0.0 ) ;
		if ( forward_pass ( pass_pos ) == TRUE ) return TRUE ;
		pass_pos += Vector ( 10.0 , -5.0 ) ;
		if ( forward_pass ( pass_pos ) == TRUE ) return TRUE ;

		return TRUE ;
	}
	return FALSE ;
}

Bool forward_pass ( Vector vec )
{
	for (Unum i = 11; i > 4 ; i-- )
	{
		if (Mem->TeammatePositionValid(i) > 0.7 )
		{
			if ( Mem->TeammateInOffsidePosition(i) )
			{
				if ( Mem->TeammateDistanceTo(i,vec) <= Mem->SP_offside_area )
					return (FALSE) ;
			}
		}
	}

	if ( Mem->BallAbsolutePosition().x > vec.x )
	{
		//kick_ball ( vec ,Mem->BestKickModeAbs((vec - Mem->TeammateAbsolutePosition(Mem->MyNumber)).dir() ),TURN_AVOID) ;
		kick_ball ( vec ,Mem->BestKickModeAbs((vec - Mem->TeammateAbsolutePosition(Mem->MyNumber)).dir() )) ;
		return TRUE ;
	}
	else
	{
		return FALSE ;
	}
}

Bool center_pass ( Vector vec )
{
	for (Unum i = 11; i > 4 ; i-- )
	{
		if (Mem->TeammatePositionValid(i) > 0.7 )
		{
			if ( Mem->TeammateInOffsidePosition(i) )
			{
				if ( Mem->TeammateDistanceTo(i,vec) <= Mem->SP_offside_area )
					return (FALSE) ;
			}
		}
	}

	if ( fabs(Mem->BallAbsolutePosition().y) < fabs(vec.y) || fabs(vec.y) < 16.0 )
	{
		//kick_ball ( vec ,Mem->BestKickModeAbs((vec - Mem->TeammateAbsolutePosition(Mem->MyNumber)).dir() ),TURN_AVOID) ;
		kick_ball ( vec ,Mem->BestKickModeAbs((vec - Mem->TeammateAbsolutePosition(Mem->MyNumber)).dir() )) ;
		return TRUE ;
	}
}

Bool kick_in_forward()
{
	for (int i = 11; i > 1 ; i-- )
	{
		if (Mem->TeammatePositionValid(i) && pass_check(i) )
		{
			if ( (!Mem->TeammateInOffsidePosition(i))
			     && ( Mem->TeammateAbsolutePosition(i).x >= Mem->TeammateAbsolutePosition(Mem->MyNumber).x ) )
			{
				if ( i == Mem->MyNumber )
					continue ;

#ifdef CMU99
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngleFromBody(i)),TURN_AVOID) ;
#else
				//kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)),TURN_AVOID) ;
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i))) ;
#endif
				return ( TRUE ) ;
			}
		}
	}
	return FALSE ;
}

Bool kick_in_center()
{
	for (int i = 11; i > 1 ; i--)
	{
		if (Mem->TeammatePositionValid(i) && pass_check(i))
		{
			if ( (!Mem->TeammateInOffsidePosition(i))
			     && ( fabs(Mem->TeammateAbsolutePosition(i).x - Mem->TeammateAbsolutePosition(Mem->MyNumber).x) < 5 )
			     && ( fabs ( Mem->TeammateAbsolutePosition(i).y) < fabs(Mem->TeammateAbsolutePosition(Mem->MyNumber).y) ))
			{
				if ( i == Mem->MyNumber )
					continue ;

#ifdef CMU99
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngleFromBody(i)),TURN_AVOID) ;
#else
				//kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i)),TURN_AVOID) ;
				kick_ball ( Mem->TeammateAbsolutePosition(i),Mem->BestKickMode(Mem->TeammateAngle(i))) ;
#endif
				return ( TRUE ) ;
			}
		}
	}
	return FALSE ;
}

void DF_clear()
{
  if ( DF_pass_forward () == TRUE ) return ;

  Vector v (0,0) ;
  if ( Mem->MyY() > 0 )
  {
	  v = Vector (51.5,33.0 ) ;
  }
  else
  {
	  v = Vector (51.5,-33.0) ;
  }

  kick_ball ( v , KM_HardestKick , TURN_AVOID) ;

}

void SW_clear()
{
  if ( MF_pass_forward () == TRUE ) return ;
  if ( MF_pass_side () == TRUE )	return ;

  Vector v (0,0) ;
  if ( Mem->MyY() > 0 )
  {
	  v = Vector (51.5,33.0 ) ;
  }
  else
  {
	  v = Vector (51.5,-33.0) ;
  }

  kick_ball ( v , KM_HardestKick ) ;
}

Bool before_kick_off()
{
  if ( Mem->KickOffMode == KO_Mine || Mem->CurrentTime == 0 || Mem->CurrentTime == 3000 || Mem->CurrentTime == 6000 )
  {
	  move_to_initial_pos() ;
	  return TRUE ;
  }
#ifdef DANCE
  else if ( Mem->KickOffMode == KO_Theirs &&  !( Mem->CurrentTime == 0 || Mem->CurrentTime == 3000 || Mem->CurrentTime == 6000 ) )
  {
#ifdef MOVING
	  dancing ( 20 ) ;
#else
	  dancing ( 40 ) ;
#endif
	  return TRUE ;

  }
#else
  else if ( Mem->KickOffMode == KO_Theirs )
  {
	  move_to_initial_pos() ;
	  return TRUE ;

  }
#endif
	  return FALSE ;

}

void move_to_initial_pos()
{
  char saybuf[512] ;
  char sendbuf[512] ;
  
  if ( Mem->CP_role == 1 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d GK)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 2 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d DF)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 3 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d DF)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 4 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d DF)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 5 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d DH)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 6 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d CMF)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 7 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d LMF)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 8 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d RMF)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 9 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d OH)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 10 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d LFW)", Mem->CP_role ) ;
  else if ( Mem->CP_role == 11 )
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d RFW)", Mem->CP_role ) ;
  else
	  sprintf ( saybuf,"(say Zeng99-ACamp99+alpha %d )", Mem->CP_role ) ;

  strncpy(sendbuf,saybuf,(strlen(saybuf) >Mem->SP_say_msg_size - 1) ?
	  Mem->SP_say_msg_size - 1 : strlen(saybuf) ) ;
  if ( sendbuf[strlen(sendbuf)] != ')' )
	  strcat(sendbuf,")") ;

  if ( Mem->KickOffMode == KO_Mine )
  {
	  if (MyProp->init_pos.dist(Mem->MyPos()) > 1)
	  {
#ifndef MOVING
		  move(MyProp->init_pos);
#else
#ifdef dance
		  dash_init_position_with_move(MyProp->init_pos2,20);
#else
		  dash_init_position_with_move(MyProp->init_pos2);
#endif
#endif
	  }
	  else if ( say_counter ++ < 1 )
	  {
		  send_message( sendbuf, Mem->sock ) ;
		  
	  }
  }
  else if ( Mem->KickOffMode == KO_Theirs )
  {
	  if (MyProp->init_pos2.dist(Mem->MyPos()) > 1)
	  {
#ifndef MOVING
		  move(MyProp->init_pos2);
#else
#ifdef dance
		  dash_init_position_with_move(MyProp->init_pos2,20);
#else
		  dash_init_position_with_move(MyProp->init_pos2);
#endif
#endif
	  }
	  else if ( say_counter ++ < 1 )
	  {
		  send_message( sendbuf, Mem->sock ) ;
	  }
  }
}

/////////////////
/*    Kubo     */
/////////////////
ActionQueueRes go_to_initial_pos(double pow)
{
	return go_to_point(MyProp->init_pos, 5, pow);
}

ActionQueueRes go_to_pos(double pow)
{
	return go_to_point(MyProp->pos, 5, pow);
}

ActionQueueRes go_to_pos2(double pow)
{
	return go_to_point(MyProp->pos2, 5, pow);
}

void return_to_initial_pos(int dash_pow)
{
	if(go_to_point(MyProp->pos, 1, dash_pow) == AQ_ActionNotQueued)
		face_ball();
}

Bool my_kick_in(void)
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallKickable() )
	{
		if ( kick_in_forward() == TRUE ) return TRUE ;
		if ( kick_in_center() == TRUE ) return TRUE ;

		if ( Mem->BallAbsolutePosition().y > 0 )
		{
			kick_to_xy(Vector(Mem->BallAbsolutePosition().x+1.0,
					  Mem->BallAbsolutePosition().y-1.0) ) ;
		}
		else
		{
			kick_to_xy(Vector(Mem->BallAbsolutePosition().x+1.0,
					  Mem->BallAbsolutePosition().y+1.0) ) ;
		}
		return TRUE ;
	}
	else
	{
		if ( Mem->BallPositionValid() )
		{
			if ( Mem->ClosestTeammateToBall() == Mem->MyNumber 
			     || ( Mem->ClosestTeammateToBall() == 1 && how_many_closer_teammate(Mem->BallAbsolutePosition()) < 2 ) )
			{
				if ( go_to_point ( Mem->BallAbsolutePosition() , Mem->SP_ball_size + 0.5 , 20 ) == AQ_ActionNotQueued )
				{
					if ( scan_field() ==  AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return TRUE ;
			}
			else
			{
				if ( Mem->TeammateInOffsidePosition(Mem->MyNumber ) )
				{
					if ( go_to_point (Vector (Mem->my_offside_line - MyProp->offside_line_offset , MyProp->my_kickin.y)
							  , buffer , 40 ) == AQ_ActionNotQueued )
					{
						if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
						return TRUE ;
					}
					return TRUE ;
				}
				else
				{
					if ( go_to_point(MyProp->my_kickin ,buffer,50) == AQ_ActionNotQueued )
					{
						if ( face_ball() == AQ_ActionNotQueued ) return FALSE ;
						return TRUE ;
					}
					return TRUE ;
				}
			}
		}
		else
		{
			face_ball() ;
			return TRUE ;
		}
	}
	return FALSE ;
}

Bool their_kick_in ( void )
{
	double buffer = minimal_buffer() ;

	if ( Mem->BallPositionValid() > 0.7 )
	{
		if ( Mem->ClosestTeammateToBall() == Mem->MyNumber )
		{
			if ( Mem->BallDistance() > buffer )
			{
				if ( my_go_to_position ( Mem->BallAbsolutePosition() , Vector( -40,0 ) , buffer + 3 , 40 ,2.0 ) == TRUE ) return TRUE ;
				return FALSE ;
			}
			else
			{
				if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
		}
		else if ( fabs(Mem->BallAbsolutePosition().x - MyProp->their_kickin.x ) < 10 )
		{
			if ( Mem->BallDistance() > buffer )
			{
				if ( go_to_point ( Vector (MyProp ->their_kickin.x,MyProp->pos2.y) , 2.0 , 35 ) == AQ_ActionNotQueued )
				{
					if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return ( TRUE ) ;
			}
			else
			{
				if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
				return TRUE ;
			}
		}
		else
		{
			if ( Mem->BallDistance() > buffer )
			{
				if ( go_to_point ( MyProp ->their_kickin , 2.0 , 35 ) == AQ_ActionNotQueued )
				{
					if ( face_ball() ==  AQ_ActionNotQueued ) return FALSE ;
					return TRUE ;
				}
				return ( TRUE ) ;
			}
			else
			{
				face_ball() ;
				return ( TRUE ) ;
			}
		}
	}
	else
	{
		face_ball() ;
		return ( TRUE ) ;
	}
}

Bool get_ball_to_own(double buffer)
{
	Vector v ;

	if ( Mem->BallVelocityValid() )
	{
		if ( player_is_dribble() == TRUE )
		{
			return FALSE ;
		}

		if ( Mem->BallSpeed() > 1.2 )
		{
			if ( Mem->MyInterceptionAble() )
			{
				v = Mem->MyInterceptionPoint() ;
			}
			else
			{
				v = Mem->BallAbsolutePosition() ;
			}
		}
		else
		{
			if ( Mem->MyInterceptionAble() )
			{
				v = Mem->MyInterceptionPoint() ;
			}
			else
			{
				v = Mem->BallAbsolutePosition() ;
			}
		}
	}
	else
	{
		if ( Mem->PlayerWithBall ( - 0.5 ) > 0 && Mem->PlayerWithBall() != Mem->MyNumber )
		{
			return FALSE ;
		}
		if ( Mem->MyInterceptionAble() )
		{
			v = Mem->MyInterceptionPoint() ;
		}
		else
		{
			v = Mem->BallAbsolutePosition() ;
		}
	}

	if ( go_to_point ( v, buffer , 100 ) == AQ_ActionNotQueued )
	{
		face_ball();
		return TRUE ;
	}
	return TRUE ;
}
