#! /usr/local/bin/wish8.0

#set soccer server path
set sserver_path  /home/kubo/RoboCup/sserver-5.25
set logplayer_cmd $sserver_path/logplayer/logplayer
set logplayer_pid 0

set monitor_cmd   $sserver_path/monitor/soccermonitor
set monitor_pid   0
set monitor_size  normal

proc kill_log {} {
    global logplayer_pid
    if { $logplayer_pid != 0 } {
	catch {exec kill $logplayer_pid}
	set logplayer_pid 0
    }
    global monitor_pid
    if { $monitor_pid != 0 } {
	catch {exec kill $monitor_pid}
	set monitor_pid 0
    }
}

proc play_log {logfile} {
    kill_log
    if {$logfile != ""} {
	global logplayer_cmd
	global logplayer_pid
	set logplayer_pid [exec $logplayer_cmd $logfile &]
	exec_monitor
    }
}

proc exec_monitor {} {
    global monitor_size
    global sserver_path
    set monitor_flag ""
    if { $monitor_size != "normal" } {
	global sserver_path
	set monitor_flag "-file $sserver_path/monitor/monitor.conf.large -ball_file_name $sserver_path/monitor/ball-l.xbm"
    } else {
	set monitor_flag "-file $sserver_path/monitor/monitor.conf -ball_file_name $sserver_path/monitor/ball-s.xbm"
    }
    global monitor_cmd
    global monitor_pid
    set cmd "$monitor_cmd $monitor_flag"
    set monitor_pid   [eval "exec $cmd &"] 
}


proc monitor_size_switch {} {
    global monitor_size
    if { $monitor_size == "normal" } {
	set monitor_size large
    } else {
	set monitor_size normal
    }
    global monitor_pid
    if { $monitor_pid != 0 } {
	catch {exec kill $monitor_pid}
	exec_monitor
    }
}

proc quit_func {} {
    kill_log
    exit
}

button .play -text "play log" -command {
    set logfile [tk_getOpenFile]
    puts $logfile
    play_log $logfile
}

button .size_switch -text size -command monitor_size_switch

button .quit -text quit -command quit_func

pack .play .size_switch .quit -fill x

